/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2206 from the
 * contents of Virt.xs. Do not edit this file, edit Virt.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Virt.xs"
/* -*- c -*-
 *
 * Copyright (C) 2006 Red Hat
 * Copyright (C) 2006-2007 Daniel P. Berrange
 *
 * This program is free software; You can redistribute it and/or modify
 * it under either:
 *
 * a) the GNU General Public License as published by the Free
 *   Software Foundation; either version 2, or (at your option) any
 *   later version,
 *
 * or
 *
 * b) the "Artistic License"
 *
 * The file "LICENSE" distributed along with this file provides full
 * details of the terms and conditions of the two licenses.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <libvirt/virterror.h>
#include <libvirt/libvirt.h>

/*
 * On 32-bit OS (and some 64-bit) Perl does not have an
 * integer type capable of storing 64 bit numbers. So
 * we serialize to/from strings on these platforms
 */

long long
virt_SvIVll(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvIV(sv);
#else
    return strtoll(SvPV_nolen(sv), NULL, 10);
#endif
}


unsigned long long
virt_SvIVull(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvIV(sv);
#else
    return strtoull(SvPV_nolen(sv), NULL, 10);
#endif
}


#ifndef PRId64
#define PRId64 "lld"
#endif


SV *
virt_newSVll(long long val) {
#ifdef USE_64_BIT_ALL
    return newSViv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRId64, val);
    return newSVpv(buf, len);
#endif
}


#ifndef PRIu64
#define PRIu64 "llu"
#endif

SV *
virt_newSVull(unsigned long long val) {
#ifdef USE_64_BIT_ALL
    return newSVuv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRIu64, val);
    return newSVpv(buf, len);
#endif
}



void ignoreVirErrorFunc(void * userData, virErrorPtr error) {
  /* Do nothing */
}


SV *
_sv_from_error(virErrorPtr error)
{
    HV *hv;

    hv = newHV ();

    /* Map virErrorPtr attributes to hash keys */
    (void)hv_store (hv, "level", 5, newSViv (error ? error->level : 0), 0);
    (void)hv_store (hv, "code", 4, newSViv (error ? error->code : 0), 0);
    (void)hv_store (hv, "domain", 6, newSViv (error ? error->domain : VIR_FROM_NONE), 0);
    (void)hv_store (hv, "message", 7, newSVpv (error && error->message ? error->message : "Unknown problem", 0), 0);

    return sv_bless (newRV_noinc ((SV*) hv), gv_stashpv ("Sys::Virt::Error", TRUE));
}


void
_croak_error(void)
{
    virErrorPtr error = virGetLastError();
    sv_setsv(ERRSV, _sv_from_error (error));

    /* croak does not return, so we free this now to avoid leaking */
    virResetError(error);

    croak (Nullch);
}


void
_populate_constant(HV *stash, char *name, int val)
{
    SV *valsv;

    valsv = newSViv(0);
    sv_setuv(valsv,val);
    newCONSTSUB(stash, name, valsv);
}


void
_populate_constant_str(HV *stash, char *name, const char *value)
{
    SV *valsv;

    valsv = newSVpv(value, strlen(value));
    newCONSTSUB(stash, name, valsv);
}


void
_populate_constant_ull(HV *stash, char *name, unsigned long long val)
{
    SV *valsv;

    valsv = virt_newSVull(val);
    newCONSTSUB(stash, name, valsv);
}


#define REGISTER_CONSTANT(name, key) _populate_constant(stash, #key, name)
#define REGISTER_CONSTANT_STR(name, key) _populate_constant_str(stash, #key, name)
#define REGISTER_CONSTANT_ULL(name, key) _populate_constant_ull(stash, #key, name)

static int
_domain_event_lifecycle_callback(virConnectPtr con,
                                 virDomainPtr dom,
                                 int event,
                                 int detail,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(event)));
    XPUSHs(sv_2mortal(newSViv(detail)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_generic_callback(virConnectPtr con,
                               virDomainPtr dom,
                               void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_rtcchange_callback(virConnectPtr con,
                                 virDomainPtr dom,
                                 long long utcoffset,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(virt_newSVll(utcoffset)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_watchdog_callback(virConnectPtr con,
                                virDomainPtr dom,
                                int action,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(action)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_io_error_callback(virConnectPtr con,
                                virDomainPtr dom,
                                const char *srcPath,
                                const char *devAlias,
                                int action,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(srcPath, 0)));
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    XPUSHs(sv_2mortal(newSViv(action)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_disk_change_callback(virConnectPtr con,
                                   virDomainPtr dom,
                                   const char *oldSrcPath,
                                   const char *newSrcPath,
                                   const char *devAlias,
                                   int reason,
                                   void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(oldSrcPath, 0)));
    XPUSHs(sv_2mortal(newSVpv(newSrcPath, 0)));
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_tray_change_callback(virConnectPtr con,
                                   virDomainPtr dom,
                                   const char *devAlias,
                                   int reason,
                                   void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_pmwakeup_callback(virConnectPtr con,
                                virDomainPtr dom,
                                int reason,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_pmsuspend_callback(virConnectPtr con,
                                 virDomainPtr dom,
                                 int reason,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_io_error_reason_callback(virConnectPtr con,
                                       virDomainPtr dom,
                                       const char *srcPath,
                                       const char *devAlias,
                                       int action,
                                       const char *reason,
                                       void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(srcPath, 0)));
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    XPUSHs(sv_2mortal(newSViv(action)));
    XPUSHs(sv_2mortal(newSVpv(reason, 0)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_graphics_callback(virConnectPtr con,
                                virDomainPtr dom,
                                int phase,
                                virDomainEventGraphicsAddressPtr local,
                                virDomainEventGraphicsAddressPtr remote,
                                const char *authScheme,
                                virDomainEventGraphicsSubjectPtr subject,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    HV *local_hv;
    HV *remote_hv;
    AV *subject_av;
    int i;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    local_hv = newHV();
    (void)hv_store(local_hv, "family", 6, newSViv(local->family), 0);
    (void)hv_store(local_hv, "node", 4, newSVpv(local->node, 0), 0);
    (void)hv_store(local_hv, "service", 7, newSVpv(local->service, 0), 0);

    remote_hv = newHV();
    (void)hv_store(remote_hv, "family", 6, newSViv(remote->family), 0);
    (void)hv_store(remote_hv, "node", 4, newSVpv(remote->node, 0), 0);
    (void)hv_store(remote_hv, "service", 7, newSVpv(remote->service, 0), 0);

    subject_av = newAV();
    for (i = 0 ; i < subject->nidentity ; i++) {
        HV *identity = newHV();
        (void)hv_store(identity, "type", 4, newSVpv(subject->identities[i].type, 0), 0);
        (void)hv_store(identity, "name", 4, newSVpv(subject->identities[i].name, 0), 0);

        av_push(subject_av, newRV_noinc((SV *)identity));
    }

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(phase)));
    XPUSHs(newRV_noinc((SV*)local_hv));
    XPUSHs(newRV_noinc((SV*)remote_hv));
    XPUSHs(sv_2mortal(newSVpv(authScheme, 0)));
    XPUSHs(newRV_noinc((SV*)subject_av));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_block_job_callback(virConnectPtr con,
                                 virDomainPtr dom,
                                 const char *path,
                                 int type,
                                 int status,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(path, 0)));
    XPUSHs(sv_2mortal(newSViv(type)));
    XPUSHs(sv_2mortal(newSViv(status)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static void
_domain_event_free(void *opaque)
{
  SV *sv = opaque;
  SvREFCNT_dec(sv);
}


static int
_event_add_handle(int fd,
		  int events,
		  virEventHandleCallback cb,
		  void *opaque,
		  virFreeCallback ff)
{
    SV *cbref;
    SV *opaqueref;
    SV *ffref;
    int ret;
    int watch = 0;
    dSP;

    ENTER;
    SAVETMPS;

    cbref= sv_newmortal();
    opaqueref= sv_newmortal();
    ffref= sv_newmortal();

    sv_setref_pv(cbref, NULL, cb);
    sv_setref_pv(opaqueref, NULL, opaque);
    sv_setref_pv(ffref, NULL, ff);

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(fd)));
    XPUSHs(sv_2mortal(newSViv(events)));
    XPUSHs(cbref);
    XPUSHs(opaqueref);
    XPUSHs(ffref);
    PUTBACK;

    ret = call_pv("Sys::Virt::Event::_add_handle", G_SCALAR);

    SPAGAIN;

    if (ret == 1)
      watch = POPi;

    FREETMPS;
    LEAVE;

    if (ret != 1)
      return -1;

    return watch;
}


static void
_event_update_handle(int watch,
		     int events)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    XPUSHs(sv_2mortal(newSViv(events)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_update_handle", G_DISCARD);

    FREETMPS;
    LEAVE;
}


static int
_event_remove_handle(int watch)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_remove_handle", G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
    return 0;
}


static int
_event_add_timeout(int interval,
		   virEventTimeoutCallback cb,
		   void *opaque,
		   virFreeCallback ff)
{
    SV *cbref;
    SV *opaqueref;
    SV *ffref;
    int ret;
    int timer = 0;
    dSP;

    ENTER;
    SAVETMPS;

    cbref = sv_newmortal();
    opaqueref = sv_newmortal();
    ffref = sv_newmortal();

    sv_setref_pv(cbref, NULL, cb);
    sv_setref_pv(opaqueref, NULL, opaque);
    sv_setref_pv(ffref, NULL, ff);

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(interval)));
    XPUSHs(cbref);
    XPUSHs(opaqueref);
    XPUSHs(ffref);
    PUTBACK;

    ret = call_pv("Sys::Virt::Event::_add_timeout", G_SCALAR);

    SPAGAIN;

    if (ret == 1)
      timer = POPi;

    FREETMPS;
    LEAVE;

    if (ret != 1)
      return -1;

    return timer;
}


static void
_event_update_timeout(int timer,
		      int interval)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    XPUSHs(sv_2mortal(newSViv(interval)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_update_timeout", G_DISCARD);

    FREETMPS;
    LEAVE;
}


static int
_event_remove_timeout(int timer)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_remove_timeout", G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_open_auth_callback(virConnectCredentialPtr cred,
		    unsigned int ncred,
		    void *cbdata)
{
  dSP;
  int i, ret, success = -1;
  AV *credlist;

  credlist = newAV();

  ENTER;
  SAVETMPS;
  PUSHMARK(SP);

  for (i = 0 ; i < ncred ; i++) {
      HV *credrec = newHV();

      (void)hv_store(credrec, "type", 4, newSViv(cred[i].type), 0);
      (void)hv_store(credrec, "prompt", 6, newSVpv(cred[i].prompt, 0), 0);
      (void)hv_store(credrec, "challenge", 9, newSVpv(cred[i].challenge, 0), 0);
      if (cred[i].defresult != NULL)
          (void)hv_store(credrec, "result", 6, newSVpv(cred[i].defresult, 0), 0);
      else
          (void)hv_fetch(credrec, "result", 6, 1);

      av_push(credlist, newRV_noinc((SV *)credrec));
  }
  SvREFCNT_inc((SV*)credlist);

  XPUSHs(newRV_noinc((SV*)credlist));
  PUTBACK;

  ret = call_sv((SV*)cbdata, G_SCALAR);

  SPAGAIN;

  if (ret == 1)
     success = POPi;

  for (i = 0 ; i < ncred ; i++) {
      SV **credsv = av_fetch(credlist, i, 0);
      HV *credrec = (HV*)SvRV(*credsv);
      SV **val = hv_fetch(credrec, "result", 6, 0);

      if (val && SvOK(*val)) {
	  STRLEN len;
	  char *result = SvPV(*val, len);
	  if (!(cred[i].result = malloc(len+1)))
	      abort();
	  memcpy(cred[i].result, result, len+1);
	  cred[i].resultlen = (unsigned int)len;
      } else {
	  cred[i].resultlen = 0;
	  cred[i].result = NULL;
      }
  }

  FREETMPS;
  LEAVE;

  return success;
}


static void
_event_handle_helper(int watch,
                     int fd,
                     int events,
                     void *opaque)
{
    SV *cb = opaque;
    dSP;

    SvREFCNT_inc(cb);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    XPUSHs(sv_2mortal(newSViv(fd)));
    XPUSHs(sv_2mortal(newSViv(events)));
    PUTBACK;

    call_sv(cb, G_DISCARD);

    FREETMPS;
    LEAVE;
}


static void
_event_timeout_helper(int timer,
                      void *opaque)
{
    SV *cb = opaque;
    dSP;

    SvREFCNT_inc(cb);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    PUTBACK;

    call_sv(cb, G_DISCARD);

    FREETMPS;
    LEAVE;
}


static void
_event_cb_free(void *opaque)
{
    SV *data = opaque;
    SvREFCNT_dec(data);
}


static void
_stream_event_callback(virStreamPtr st,
                       int events,
                       void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(sv_2mortal(newSViv(events)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;
}


static void
_stream_event_free(void *opaque)
{
    AV *data = opaque;
    SvREFCNT_dec(data);
}


static int
_stream_send_all_source(virStreamPtr st,
                        char *data,
                        size_t nbytes,
                        void *opaque)
{
    AV *av = opaque;
    SV **self;
    SV **handler;
    SV *datasv;
    int rv;
    int ret;
    dSP;

    self = av_fetch(av, 0, 0);
    handler = av_fetch(av, 1, 0);
    datasv = newSVpv("", 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(datasv);
    XPUSHs(sv_2mortal(newSViv(nbytes)));
    PUTBACK;

    rv = call_sv((SV*)*handler, G_SCALAR);

    SPAGAIN;

    if (rv == 1) {
        ret = POPi;
    } else {
        ret = -1;
    }

    if (ret > 0) {
        const char *newdata = SvPV_nolen(datasv);
        if (ret > nbytes)
            ret = nbytes;
        strncpy(data, newdata, nbytes);
    }

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(datasv);

    return ret;
}


static int
_stream_recv_all_sink(virStreamPtr st,
                      const char *data,
                      size_t nbytes,
                      void *opaque)
{
    AV *av = opaque;
    SV **self;
    SV **handler;
    SV *datasv;
    int rv;
    int ret;
    dSP;

    self = av_fetch(av, 0, 0);
    handler = av_fetch(av, 1, 0);
    datasv = newSVpv(data, nbytes);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(datasv);
    XPUSHs(sv_2mortal(newSViv(nbytes)));
    PUTBACK;

    rv = call_sv((SV*)*handler, G_SCALAR);

    SPAGAIN;

    if (rv == 1) {
        ret = POPi;
    } else {
        ret = -1;
    }

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(datasv);

    return ret;
}


static HV *
vir_typed_param_to_hv(virTypedParameter *params, int nparams)
{
    HV *ret = (HV *)sv_2mortal((SV*)newHV());
    unsigned int i;
    const char *field;
    STRLEN val_length;

    for (i = 0 ; i < nparams ; i++) {
        SV *val = NULL;

        switch (params[i].type) {
        case VIR_TYPED_PARAM_INT:
            val = newSViv(params[i].value.i);
            break;

        case VIR_TYPED_PARAM_UINT:
            val = newSViv((int)params[i].value.ui);
            break;

        case VIR_TYPED_PARAM_LLONG:
            val = virt_newSVll(params[i].value.l);
            break;

        case VIR_TYPED_PARAM_ULLONG:
            val = virt_newSVull(params[i].value.ul);
            break;

        case VIR_TYPED_PARAM_DOUBLE:
            val = newSVnv(params[i].value.d);
            break;

        case VIR_TYPED_PARAM_BOOLEAN:
            val = newSViv(params[i].value.b);
            break;

        case VIR_TYPED_PARAM_STRING:
            val_length = strlen(params[i].value.s);
            val = newSVpv(params[i].value.s, val_length);
            break;

        }

        field = params[i].field;
        (void)hv_store(ret, field, strlen(params[i].field), val, 0);
    }

    return ret;
}


static int
vir_typed_param_from_hv(HV *newparams, virTypedParameter *params, int nparams)
{
    unsigned int i;
    char * ptr;
    STRLEN len;
    int needString = 0;

    for (i = 0 ; i < nparams ; i++) {
        SV **val;

        if (!hv_exists(newparams, params[i].field, strlen(params[i].field)))
            continue;

        val = hv_fetch (newparams, params[i].field, strlen(params[i].field), 0);

        switch (params[i].type) {
        case VIR_TYPED_PARAM_INT:
            params[i].value.i = SvIV(*val);
            break;

        case VIR_TYPED_PARAM_UINT:
            params[i].value.ui = SvIV(*val);
            break;

        case VIR_TYPED_PARAM_LLONG:
            params[i].value.l = virt_SvIVll(*val);
            break;

        case VIR_TYPED_PARAM_ULLONG:
            params[i].value.ul = virt_SvIVull(*val);
            break;

        case VIR_TYPED_PARAM_DOUBLE:
            params[i].value.d = SvNV(*val);
            break;

        case VIR_TYPED_PARAM_BOOLEAN:
            params[i].value.b = SvIV(*val);
            break;

        case VIR_TYPED_PARAM_STRING:
            needString = 1;
            ptr = SvPV(*val, len);
            params[i].value.s = (char *)ptr;
            break;
        }
    }
    return needString;
}


#line 1237 "Virt.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 1289 "Virt.c"

XS(XS_Sys__Virt__open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "name, flags");
    {
	SV *	name = ST(0);
	unsigned int	flags = (unsigned int)SvUV(ST(1));
#line 1236 "Virt.xs"
      const char *uri = NULL;
#line 1306 "Virt.c"
	virConnectPtr	RETVAL;
#line 1238 "Virt.xs"
      if (SvOK(name))
	  uri = SvPV_nolen(name);

      if (!(RETVAL = virConnectOpenAuth(uri, NULL, flags)))
          _croak_error();
#line 1314 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__open_auth); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__open_auth)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "name, creds, cb, flags");
    {
	SV *	name = ST(0);
	SV *	creds = ST(1);
	SV *	cb = ST(2);
	unsigned int	flags = (unsigned int)SvUV(ST(3));
#line 1254 "Virt.xs"
      AV *credlist;
      virConnectAuth auth;
      int i;
      const char *uri = NULL;
#line 1345 "Virt.c"
	virConnectPtr	RETVAL;
#line 1259 "Virt.xs"
      if (SvOK(name))
	  uri = SvPV_nolen(name);

      if (SvOK(cb) && SvOK(creds)) {
	  memset(&auth, 0, sizeof auth);
	  credlist = (AV*)SvRV(creds);
	  auth.ncredtype = av_len(credlist) + 1;
	  Newx(auth.credtype, auth.ncredtype, int);
	  for (i = 0 ; i < auth.ncredtype ; i++) {
	    SV **type = av_fetch(credlist, i, 0);
	    auth.credtype[i] = SvIV(*type);
	  }

	  auth.cb = _open_auth_callback;
	  auth.cbdata = cb;
	  RETVAL = virConnectOpenAuth(uri,
				      &auth,
                                      flags);
	  Safefree(auth.credtype);
      } else {
	  RETVAL = virConnectOpenAuth(uri,
				      virConnectAuthPtrDefault,
                                      flags);
      }
      if (!RETVAL)
	_croak_error();
#line 1374 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_restore_domain); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_restore_domain)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "con, from, dxmlsv=&PL_sv_undef, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	const char *	from = (const char *)SvPV_nolen(ST(1));
	SV *	dxmlsv;
	unsigned int	flags;
#line 1296 "Virt.xs"
      const char *dxml = NULL;
#line 1404 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::restore_domain() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    dxmlsv = &PL_sv_undef;
	else {
	    dxmlsv = ST(2);
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 1298 "Virt.xs"
      if (SvOK(dxmlsv))
	  dxml = SvPV_nolen(dxmlsv);

      if (dxml || flags) {
          if (virDomainRestoreFlags(con, from, dxml, flags) < 0)
              _croak_error();
      } else {
          if (virDomainRestore(con, from) < 0)
              _croak_error();
      }
#line 1435 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_get_save_image_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_save_image_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, file, flags=0");
    {
	virConnectPtr	con;
	const char *	file = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
#line 1316 "Virt.xs"
      char *xml;
#line 1458 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_save_image_xml_description() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 1318 "Virt.xs"
      if (!(xml = virDomainSaveImageGetXMLDesc(con, file, flags)))
	 _croak_error();
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 1478 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_define_save_image_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_define_save_image_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, file, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	const char *	file = (const char *)SvPV_nolen(ST(1));
	const char *	xml = (const char *)SvPV_nolen(ST(2));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::define_save_image_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 1333 "Virt.xs"
      if (virDomainSaveImageDefineXML(con, file, xml, flags) < 0)
          _croak_error();
#line 1519 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__get_library_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__get_library_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "void");
    {
#line 1341 "Virt.xs"
      unsigned long version;
#line 1539 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;
#line 1343 "Virt.xs"
      if (virGetVersion(&version, NULL, NULL) < 0)
          _croak_error();
      RETVAL = version;
#line 1546 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__get_conn_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__get_conn_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1354 "Virt.xs"
      unsigned long version;
#line 1567 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::_get_conn_version() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1356 "Virt.xs"
      if (virConnectGetVersion(con, &version) < 0)
          _croak_error();
      RETVAL = version;
#line 1581 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__get_conn_library_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__get_conn_library_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1367 "Virt.xs"
      unsigned long version;
#line 1602 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::_get_conn_library_version() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1369 "Virt.xs"
      if (virConnectGetLibVersion(con, &version) < 0)
          _croak_error();
      RETVAL = version;
#line 1616 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_is_encrypted); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_is_encrypted)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	virConnectPtr	conn;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::is_encrypted() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1380 "Virt.xs"
      if ((RETVAL = virConnectIsEncrypted(conn)) < 0)
          _croak_error();
#line 1647 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_is_secure); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_is_secure)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	virConnectPtr	conn;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::is_secure() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1390 "Virt.xs"
      if ((RETVAL = virConnectIsSecure(conn)) < 0)
          _croak_error();
#line 1678 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_is_alive); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_is_alive)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	virConnectPtr	conn;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::is_alive() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1400 "Virt.xs"
      if ((RETVAL = virConnectIsAlive(conn)) < 0)
          _croak_error();
#line 1709 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_set_keep_alive); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_set_keep_alive)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "conn, interval, count");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	int	interval = (int)SvIV(ST(1));
	unsigned int	count = (unsigned int)SvUV(ST(2));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::set_keep_alive() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1412 "Virt.xs"
      if (virConnectSetKeepAlive(conn, interval, count) < 0)
          _croak_error();
#line 1742 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_get_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_type() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1420 "Virt.xs"
      RETVAL = virConnectGetType(con);
#line 1772 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_uri); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_uri)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_uri() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1429 "Virt.xs"
      RETVAL = virConnectGetURI(con);
#line 1802 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_sysinfo); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_sysinfo)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    {
	virConnectPtr	con;
	unsigned int	flags;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_sysinfo() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 1439 "Virt.xs"
      RETVAL = virConnectGetSysinfo(con, flags);
#line 1839 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1448 "Virt.xs"
      virNodeInfo info;
#line 1860 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_info() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1450 "Virt.xs"
      if (virNodeGetInfo(con, &info) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "model", 5, newSVpv(info.model, 0), 0);
      (void)hv_store (RETVAL, "memory", 6, newSViv(info.memory), 0);
      (void)hv_store (RETVAL, "cpus", 4, newSViv(info.cpus), 0);
      (void)hv_store (RETVAL, "mhz", 3, newSViv(info.mhz), 0);
      (void)hv_store (RETVAL, "nodes", 5, newSViv(info.nodes), 0);
      (void)hv_store (RETVAL, "sockets", 7, newSViv(info.sockets), 0);
      (void)hv_store (RETVAL, "cores", 5, newSViv(info.cores), 0);
      (void)hv_store (RETVAL, "threads", 7, newSViv(info.threads), 0);
#line 1882 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_security_model); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_security_model)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1470 "Virt.xs"
      virSecurityModel secmodel;
#line 1904 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_security_model() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1472 "Virt.xs"
      if (virNodeGetSecurityModel(con, &secmodel) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "model", 5, newSVpv(secmodel.model, 0), 0);
      (void)hv_store (RETVAL, "doi", 3, newSVpv(secmodel.doi, 0), 0);
#line 1920 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_free_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_free_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1486 "Virt.xs"
      unsigned long long mem;
#line 1942 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_free_memory() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1488 "Virt.xs"
      if ((mem = virNodeGetFreeMemory(con)) == 0)
          _croak_error();

      RETVAL = virt_newSVull(mem);
#line 1956 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_cells_free_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_cells_free_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "con, start, end");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	start = (int)SvIV(ST(1));
	int	end = (int)SvIV(ST(2));
#line 1502 "Virt.xs"
      unsigned long long *mem;
      int i, num;
#line 1983 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_cells_free_memory() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1505 "Virt.xs"
      Newx(mem, end-start, unsigned long long);
      if ((num = virNodeGetCellsFreeMemory(con, mem, start, end)) < 0) {
          Safefree(mem);
          _croak_error();
      }
      EXTEND(SP, num);
      for (i = 0 ; i < num ; i++) {
	SV *val = newSViv(mem[i]);
	PUSHs(sv_2mortal(val));
      }
      Safefree(mem);
#line 2003 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_get_node_cpu_stats); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_cpu_stats)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "con, cpuNum=VIR_NODE_CPU_STATS_ALL_CPUS, flags=0");
    {
	virConnectPtr	con;
	int	cpuNum;
	unsigned int	flags;
#line 1524 "Virt.xs"
      virNodeCPUStatsPtr params;
      int nparams = 0;
      int i;
#line 2028 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_cpu_stats() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    cpuNum = VIR_NODE_CPU_STATS_ALL_CPUS;
	else {
	    cpuNum = (int)SvIV(ST(1));
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 1528 "Virt.xs"
      if (virNodeGetCPUStats(con, cpuNum, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virNodeCPUStats);
      if (virNodeGetCPUStats(con, cpuNum, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      for (i = 0 ; i < nparams ; i++) {
          if (strcmp(params[i].field, VIR_NODE_CPU_STATS_KERNEL) == 0) {
              (void)hv_store (RETVAL, "kernel", 6, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_USER) == 0) {
              (void)hv_store (RETVAL, "user", 4, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_IDLE) == 0) {
              (void)hv_store (RETVAL, "idle", 4, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_IOWAIT) == 0) {
              (void)hv_store (RETVAL, "iowait", 6, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_UTILIZATION) == 0) {
              (void)hv_store (RETVAL, "utilization", 11, virt_newSVull(params[i].value), 0);
          }
      }
      Safefree(params);
#line 2073 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_memory_stats); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_memory_stats)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "con, cellNum=VIR_NODE_MEMORY_STATS_ALL_CELLS, flags=0");
    {
	virConnectPtr	con;
	int	cellNum;
	unsigned int	flags;
#line 1561 "Virt.xs"
      virNodeMemoryStatsPtr params;
      int nparams = 0;
      int i;
#line 2099 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_memory_stats() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    cellNum = VIR_NODE_MEMORY_STATS_ALL_CELLS;
	else {
	    cellNum = (int)SvIV(ST(1));
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 1565 "Virt.xs"
      if (virNodeGetMemoryStats(con, cellNum, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virNodeMemoryStats);
      if (virNodeGetMemoryStats(con, cellNum, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      for (i = 0 ; i < nparams ; i++) {
          if (strcmp(params[i].field, VIR_NODE_MEMORY_STATS_TOTAL) == 0) {
              (void)hv_store (RETVAL, "total", 6, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_MEMORY_STATS_FREE) == 0) {
              (void)hv_store (RETVAL, "free", 4, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_MEMORY_STATS_BUFFERS) == 0) {
              (void)hv_store (RETVAL, "buffers", 4, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_MEMORY_STATS_CACHED) == 0) {
              (void)hv_store (RETVAL, "cached", 6, virt_newSVull(params[i].value), 0);
          }
      }
      Safefree(params);
#line 2142 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_node_suspend_for_duration); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_node_suspend_for_duration)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "conn, target, duration, flags");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	unsigned int	target = (unsigned int)SvUV(ST(1));
	SV *	duration = ST(2);
	unsigned int	flags = (unsigned int)SvUV(ST(3));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::node_suspend_for_duration() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1597 "Virt.xs"
      if (virNodeSuspendForDuration(conn, target, virt_SvIVull(duration), flags) < 0)
          _croak_error();
#line 2177 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_find_storage_pool_sources); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_find_storage_pool_sources)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, type, srcspec, flags=0");
    {
	virConnectPtr	con;
	const char *	type = (const char *)SvPV_nolen(ST(1));
	const char *	srcspec = (const char *)SvPV_nolen(ST(2));
	unsigned int	flags;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::find_storage_pool_sources() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 1608 "Virt.xs"
      if ((RETVAL = virConnectFindStoragePoolSources(con, type, srcspec, flags)) == NULL)
          _croak_error();
#line 2217 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_capabilities); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_capabilities)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1618 "Virt.xs"
      char *xml;
#line 2238 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_capabilities() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1620 "Virt.xs"
      if (!(xml = virConnectGetCapabilities(con)))
          _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 2253 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_compare_cpu); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_compare_cpu)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	char *	xml = (char *)SvPV_nolen(ST(1));
	unsigned int	flags;
#line 1635 "Virt.xs"
      int rc;
#line 2277 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::compare_cpu() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 1637 "Virt.xs"
      if ((rc = virConnectCompareCPU(con, xml, flags)) < 0)
          _croak_error();

      RETVAL = newSViv(rc);
#line 2297 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_baseline_cpu); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_baseline_cpu)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	SV *	xml = ST(1);
	unsigned int	flags;
#line 1651 "Virt.xs"
      AV *xmllist;
      const char **xmlstr;
      int xmllen;
      int i;
      char *retxml;
#line 2325 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::baseline_cpu() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 1657 "Virt.xs"
      xmllist = (AV*)SvRV(xml);
      xmllen = av_len(xmllist) + 1;
      Newx(xmlstr, xmllen, const char *);
      for (i = 0 ; i < xmllen ; i++) {
          SV **doc = av_fetch(xmllist, i, 0);
          xmlstr[i] = SvPV_nolen(*doc);
      }

      if (!(retxml = virConnectBaselineCPU(con, xmlstr, xmllen, flags))) {
          Safefree(xmlstr);
          _croak_error();
      }

      Safefree(xmlstr);
      RETVAL = newSVpv(retxml, 0);
      free(retxml);
#line 2357 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_max_vcpus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_max_vcpus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, type");
    {
	virConnectPtr	con;
	char *	type = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_max_vcpus() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1682 "Virt.xs"
      if ((RETVAL = virConnectGetMaxVcpus(con, type)) < 0)
          _croak_error();
#line 2390 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_hostname); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_hostname)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1692 "Virt.xs"
      char *host;
#line 2411 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_hostname() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1694 "Virt.xs"
      if (!(host = virConnectGetHostname(con)))
          _croak_error();

      RETVAL = newSVpv(host, 0);
      free(host);
#line 2426 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_num_of_domains); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_domains)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1707 "Virt.xs"
      if ((RETVAL = virConnectNumOfDomains(con)) < 0)
	_croak_error();
#line 2458 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_domain_ids); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_domain_ids)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxids");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxids = (int)SvIV(ST(1));
#line 1718 "Virt.xs"
      int *ids;
      int i, nid;
#line 2483 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_domain_ids() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1721 "Virt.xs"
      Newx(ids, maxids, int);
      if ((nid = virConnectListDomains(con, ids, maxids)) < 0) {
          Safefree(ids);
          _croak_error();
      }
      EXTEND(SP, nid);
      for (i = 0 ; i < nid ; i++) {
          PUSHs(sv_2mortal(newSViv(ids[i])));
      }
      Safefree(ids);
#line 2502 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_domains); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_domains)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1737 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedDomains(con)) < 0)
          _croak_error();
#line 2533 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_domain_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_domain_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 1748 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 2559 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_domain_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1752 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedDomains(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 2579 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_networks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_networks)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1769 "Virt.xs"
      if ((RETVAL = virConnectNumOfNetworks(con)) < 0)
          _croak_error();
#line 2610 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_network_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_network_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 1780 "Virt.xs"
      char **names;
      int i, nnet;
#line 2635 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_network_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1783 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListNetworks(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 2655 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_networks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_networks)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1800 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedNetworks(con)) < 0)
          _croak_error();
#line 2686 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_network_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_network_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 1811 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 2712 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_network_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1815 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedNetworks(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 2732 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_storage_pools); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_storage_pools)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_storage_pools() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1832 "Virt.xs"
      if ((RETVAL = virConnectNumOfStoragePools(con)) < 0)
          _croak_error();
#line 2763 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_storage_pool_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_storage_pool_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 1843 "Virt.xs"
      char **names;
      int i, nnet;
#line 2788 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_storage_pool_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1846 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListStoragePools(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 2808 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_storage_pools); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_storage_pools)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_storage_pools() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1863 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedStoragePools(con)) < 0)
          _croak_error();
#line 2839 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_storage_pool_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_storage_pool_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 1873 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 2865 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_storage_pool_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1877 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedStoragePools(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 2885 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_node_devices); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_node_devices)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, cap, flags=0");
    {
	virConnectPtr	con;
	SV *	cap = ST(1);
	int	flags;
#line 1896 "Virt.xs"
      const char *capname = NULL;
#line 2908 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_node_devices() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2));
	}
#line 1898 "Virt.xs"
      if (SvOK(cap))
	  capname = SvPV_nolen(cap);
      if ((RETVAL = virNodeNumOfDevices(con, capname, flags)) < 0)
          _croak_error();
#line 2929 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_node_device_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_node_device_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, cap, maxnames, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	SV *	cap = ST(1);
	int	maxnames = (int)SvIV(ST(2));
	int	flags;
#line 1913 "Virt.xs"
      char **names;
      int i, nnet;
      const char *capname = NULL;
#line 2957 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_node_device_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3));
	}
#line 1917 "Virt.xs"
      if (SvOK(cap))
	  capname = SvPV_nolen(cap);
      Newx(names, maxnames, char *);
      if ((nnet = virNodeListDevices(con, capname, names, maxnames, flags)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 2985 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_interfaces); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_interfaces)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_interfaces() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1936 "Virt.xs"
      if ((RETVAL = virConnectNumOfInterfaces(con)) < 0)
          _croak_error();
#line 3016 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_interface_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_interface_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 1947 "Virt.xs"
      char **names;
      int i, nnet;
#line 3041 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_interface_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1950 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListInterfaces(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 3061 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_interfaces); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_interfaces)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_interfaces() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1967 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedInterfaces(con)) < 0)
          _croak_error();
#line 3092 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_interface_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_interface_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 1978 "Virt.xs"
      char **names;
      int i, nnet;
#line 3117 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_interface_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1981 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListDefinedInterfaces(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 3137 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_secrets); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_secrets)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_secrets() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1998 "Virt.xs"
      if ((RETVAL = virConnectNumOfSecrets(con)) < 0)
          _croak_error();
#line 3168 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_secret_uuids); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_secret_uuids)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxuuids");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxuuids = (int)SvIV(ST(1));
#line 2009 "Virt.xs"
      char **uuids;
      int i, nsecret;
#line 3193 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_secret_uuids() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2012 "Virt.xs"
      Newx(uuids, maxuuids, char *);
      if ((nsecret = virConnectListSecrets(con, uuids, maxuuids)) < 0) {
          Safefree(uuids);
          _croak_error();
      }
      EXTEND(SP, nsecret);
      for (i = 0 ; i < nsecret ; i++) {
          PUSHs(sv_2mortal(newSVpv(uuids[i], 0)));
          free(uuids[i]);
      }
      Safefree(uuids);
#line 3213 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_nwfilters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_nwfilters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_nwfilters() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2029 "Virt.xs"
      if ((RETVAL = virConnectNumOfNWFilters(con)) < 0)
          _croak_error();
#line 3244 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_nwfilter_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_nwfilter_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 2040 "Virt.xs"
      char **names;
      int i, nnet;
#line 3269 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_nwfilter_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2043 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListNWFilters(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 3289 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_domain_xml_from_native); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_domain_xml_from_native)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, configtype, configdata, flags=0");
    {
	virConnectPtr	con;
	const char *	configtype = (const char *)SvPV_nolen(ST(1));
	const char *	configdata = (const char *)SvPV_nolen(ST(2));
	unsigned int	flags;
#line 2063 "Virt.xs"
      char *xmldata;
#line 3313 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::domain_xml_from_native() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 2065 "Virt.xs"
      if (!(xmldata = virConnectDomainXMLFromNative(con, configtype, configdata, flags)))
          _croak_error();

      RETVAL = newSVpv(xmldata, 0);
      free(xmldata);
#line 3334 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_domain_xml_to_native); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_domain_xml_to_native)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, configtype, xmldata, flags=0");
    {
	virConnectPtr	con;
	const char *	configtype = (const char *)SvPV_nolen(ST(1));
	const char *	xmldata = (const char *)SvPV_nolen(ST(2));
	unsigned int	flags;
#line 2081 "Virt.xs"
      char *configdata;
#line 3359 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::domain_xml_to_native() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 2083 "Virt.xs"
      if (!(configdata = virConnectDomainXMLToNative(con, configtype, xmldata, flags)))
          _croak_error();

      RETVAL = newSVpv(configdata, 0);
      free(configdata);
#line 3380 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_domain_event_register); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_domain_event_register)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "conref, cb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	conref = ST(0);
	SV*	cb = ST(1);
#line 2097 "Virt.xs"
      AV *opaque;
      virConnectPtr con;
#line 3406 "Virt.c"
#line 2100 "Virt.xs"
      con = (virConnectPtr)SvIV((SV*)SvRV(conref));
      opaque = newAV();
      SvREFCNT_inc(cb);
      SvREFCNT_inc(conref);
      av_push(opaque, conref);
      av_push(opaque, cb);
      if (virConnectDomainEventRegister(con, _domain_event_lifecycle_callback,
                                        opaque, _domain_event_free) < 0)
          _croak_error();
#line 3417 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_domain_event_deregister); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_domain_event_deregister)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::domain_event_deregister() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2115 "Virt.xs"
      virConnectDomainEventDeregister(con, _domain_event_lifecycle_callback);
#line 3447 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_domain_event_register_any); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_domain_event_register_any)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "conref, domref, eventID, cb");
    {
	SV*	conref = ST(0);
	SV*	domref = ST(1);
	int	eventID = (int)SvIV(ST(2));
	SV*	cb = ST(3);
#line 2125 "Virt.xs"
      AV *opaque;
      virConnectPtr con;
      virDomainPtr dom;
      virConnectDomainEventGenericCallback callback;
#line 3474 "Virt.c"
	int	RETVAL;
	dXSTARG;
#line 2130 "Virt.xs"
      con = (virConnectPtr)SvIV((SV*)SvRV(conref));
      if (SvOK(domref)) {
          dom = (virDomainPtr)SvIV((SV*)SvRV(domref));
      } else {
          dom = NULL;
      }

      switch (eventID) {
      case VIR_DOMAIN_EVENT_ID_LIFECYCLE:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_lifecycle_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_REBOOT:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_generic_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_RTC_CHANGE:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_rtcchange_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_WATCHDOG:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_watchdog_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_IO_ERROR:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_io_error_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_IO_ERROR_REASON:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_io_error_reason_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_GRAPHICS:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_graphics_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_CONTROL_ERROR:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_generic_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_BLOCK_JOB:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_block_job_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_DISK_CHANGE:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_disk_change_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_TRAY_CHANGE:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_tray_change_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_PMSUSPEND:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_pmsuspend_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_PMWAKEUP:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_pmwakeup_callback);
          break;
      default:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_generic_callback);
          break;
      }

      opaque = newAV();
      SvREFCNT_inc(cb);
      SvREFCNT_inc(conref);
      av_push(opaque, conref);
      av_push(opaque, cb);
      if ((RETVAL = virConnectDomainEventRegisterAny(con, dom, eventID, callback, opaque, _domain_event_free)) < 0)
          _croak_error();
#line 3537 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_domain_event_deregister_any); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_domain_event_deregister_any)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, callbackID");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	callbackID = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::domain_event_deregister_any() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2198 "Virt.xs"
      virConnectDomainEventDeregisterAny(con, callbackID);
#line 3568 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_interface_change_begin); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_interface_change_begin)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "conn, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::interface_change_begin() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 2206 "Virt.xs"
      if (virInterfaceChangeBegin(conn, flags) < 0)
          _croak_error();
#line 3606 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_interface_change_commit); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_interface_change_commit)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "conn, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::interface_change_commit() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 2215 "Virt.xs"
      if (virInterfaceChangeCommit(conn, flags) < 0)
          _croak_error();
#line 3644 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_interface_change_rollback); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_interface_change_rollback)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "conn, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::interface_change_rollback() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 2224 "Virt.xs"
      if (virInterfaceChangeRollback(conn, flags) < 0)
          _croak_error();
#line 3682 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	con_rv = ST(0);
#line 2232 "Virt.xs"
      virConnectPtr con;
#line 3705 "Virt.c"
#line 2234 "Virt.xs"
      con = (virConnectPtr)SvIV((SV*)SvRV(con_rv));
      if (con) {
	virConnectClose(con);
	sv_setiv((SV*)SvRV(con_rv), 0);
      }
#line 3712 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain__create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_create() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 2250 "Virt.xs"
      if (flags) {
          if (!(RETVAL = virDomainCreateXML(con, xml, flags)))
              _croak_error();
      } else {
          if (!(RETVAL = virDomainCreateLinux(con, xml, 0)))
              _croak_error();
      }
#line 3755 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2266 "Virt.xs"
      if (!(RETVAL = virDomainDefineXML(con, xml)))
          _croak_error();
#line 3788 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, id");
    {
	virConnectPtr	con;
	int	id = (int)SvIV(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_id() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2277 "Virt.xs"
      if (!(RETVAL = virDomainLookupByID(con, id)))
          _croak_error();
#line 3821 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2288 "Virt.xs"
      if (!(RETVAL = virDomainLookupByName(con, name)))
          _croak_error();
#line 3854 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2299 "Virt.xs"
      if (!(RETVAL = virDomainLookupByUUID(con, uuid)))
          _croak_error();
#line 3887 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2310 "Virt.xs"
      if (!(RETVAL = virDomainLookupByUUIDString(con, uuid)))
          _croak_error();
#line 3920 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_id() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2320 "Virt.xs"
      RETVAL = virDomainGetID(dom);
#line 3952 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 2329 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 3973 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_uuid() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2331 "Virt.xs"
      if ((virDomainGetUUID(dom, rawuuid)) < 0)
          _croak_error();

      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 3987 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 2343 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 4009 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_uuid_string() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2345 "Virt.xs"
      if ((virDomainGetUUIDString(dom, uuid)) < 0)
          _croak_error();

      RETVAL = newSVpv(uuid, 0);
#line 4023 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_name() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2357 "Virt.xs"
      if (!(RETVAL = virDomainGetName(dom)))
          _croak_error();
#line 4055 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_metadata); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_metadata)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "dom, type, uri=&PL_sv_undef, flags=0");
    {
	virDomainPtr	dom;
	int	type = (int)SvIV(ST(1));
	SV *	uri;
	unsigned int	flags;
#line 2370 "Virt.xs"
      const char *uristr = NULL;
#line 4079 "Virt.c"
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_metadata() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    uri = &PL_sv_undef;
	else {
	    uri = ST(2);
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 2372 "Virt.xs"
      if (SvOK(uri))
	  uristr = SvPV_nolen(uri);

      if (!(RETVAL = virDomainGetMetadata(dom, type, uristr, flags)))
          _croak_error();
#line 4107 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_metadata); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_metadata)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 6)
       croak_xs_usage(cv,  "dom, type, metadata=&PL_sv_undef, key=&PL_sv_undef, uri=&PL_sv_undef, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	type = (int)SvIV(ST(1));
	SV *	metadata;
	SV *	key;
	SV *	uri;
	unsigned int	flags;
#line 2390 "Virt.xs"
      const char *metadatastr = NULL;
      const char *keystr = NULL;
      const char *uristr = NULL;
#line 4137 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_metadata() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    metadata = &PL_sv_undef;
	else {
	    metadata = ST(2);
	}

	if (items < 4)
	    key = &PL_sv_undef;
	else {
	    key = ST(3);
	}

	if (items < 5)
	    uri = &PL_sv_undef;
	else {
	    uri = ST(4);
	}

	if (items < 6)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(5));
	}
#line 2394 "Virt.xs"
      if (SvOK(metadata))
	  metadatastr = SvPV_nolen(metadata);
      if (SvOK(key))
	  keystr = SvPV_nolen(key);
      if (SvOK(uri))
	  uristr = SvPV_nolen(uri);

      if (virDomainSetMetadata(dom, type, metadatastr, keystr, uristr, flags) < 0)
          _croak_error();
#line 4179 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_is_active); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_is_active)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::is_active() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2410 "Virt.xs"
      if ((RETVAL = virDomainIsActive(dom)) < 0)
          _croak_error();
#line 4210 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_is_persistent); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_is_persistent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::is_persistent() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2420 "Virt.xs"
      if ((RETVAL = virDomainIsPersistent(dom)) < 0)
          _croak_error();
#line 4241 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_is_updated); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_is_updated)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::is_updated() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2430 "Virt.xs"
      if ((RETVAL = virDomainIsUpdated(dom)) < 0)
          _croak_error();
#line 4272 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_suspend); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_suspend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::suspend() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2440 "Virt.xs"
      if ((virDomainSuspend(dom)) < 0)
          _croak_error();
#line 4303 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_resume); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_resume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::resume() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2448 "Virt.xs"
      if ((virDomainResume(dom)) < 0)
          _croak_error();
#line 4334 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_pm_wakeup); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_pm_wakeup)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, flags");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags = (unsigned int)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::pm_wakeup() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2457 "Virt.xs"
      if ((virDomainPMWakeup(dom, flags)) < 0)
          _croak_error();
#line 4366 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_save); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_save)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "dom, to, dxmlsv=&PL_sv_undef, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	to = (const char *)SvPV_nolen(ST(1));
	SV *	dxmlsv;
	unsigned int	flags;
#line 2468 "Virt.xs"
      const char *dxml = NULL;
#line 4392 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::save() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    dxmlsv = &PL_sv_undef;
	else {
	    dxmlsv = ST(2);
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 2470 "Virt.xs"
      if (SvOK(dxmlsv))
	  dxml = SvPV_nolen(dxmlsv);

      if (dxml || flags) {
          if ((virDomainSaveFlags(dom, to, dxml, flags)) < 0)
              _croak_error();
      } else {
          if ((virDomainSave(dom, to)) < 0)
              _croak_error();
      }
#line 4423 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_managed_save); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_managed_save)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::managed_save() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 2487 "Virt.xs"
      if ((virDomainManagedSave(dom, flags)) < 0)
          _croak_error();
#line 4461 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_has_managed_save_image); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_has_managed_save_image)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::has_managed_save_image() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 2496 "Virt.xs"
      if ((RETVAL = virDomainHasManagedSaveImage(dom, flags)) < 0)
          _croak_error();
#line 4499 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_managed_save_remove); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_managed_save_remove)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::managed_save_remove() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 2507 "Virt.xs"
      if ((virDomainManagedSaveRemove(dom, flags)) < 0)
          _croak_error();
#line 4537 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_core_dump); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_core_dump)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, to, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	to = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::core_dump() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 2517 "Virt.xs"
      if (virDomainCoreDump(dom, to, flags) < 0)
          _croak_error();
#line 4576 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 2525 "Virt.xs"
      virDomainInfo info;
#line 4597 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2527 "Virt.xs"
      if (virDomainGetInfo(dom, &info) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
      (void)hv_store (RETVAL, "maxMem", 6, newSViv(info.maxMem), 0);
      (void)hv_store (RETVAL, "memory", 6, newSViv(info.memory), 0);
      (void)hv_store (RETVAL, "nrVirtCpu", 9, newSViv(info.nrVirtCpu), 0);
      (void)hv_store (RETVAL, "cpuTime", 7, virt_newSVull(info.cpuTime), 0);
#line 4616 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_control_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_control_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 2545 "Virt.xs"
      virDomainControlInfo info;
#line 4639 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_control_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 2547 "Virt.xs"
      if (virDomainGetControlInfo(dom, &info, flags) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
      (void)hv_store (RETVAL, "details", 7, newSViv(info.details), 0);
      (void)hv_store (RETVAL, "stateTime", 9, virt_newSVull(info.stateTime), 0);
#line 4662 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_state); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_state)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 2563 "Virt.xs"
      int state;
      int reason;
#line 4688 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_state() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 2566 "Virt.xs"
      if (virDomainGetState(dom, &state, &reason, flags) < 0)
          _croak_error();

      XPUSHs(sv_2mortal(newSViv(state)));
      XPUSHs(sv_2mortal(newSViv(reason)));
#line 4708 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_open_console); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_open_console)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, st, devname, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	virStreamPtr	st;
	SV *	devname = ST(2);
	unsigned int	flags;
#line 2580 "Virt.xs"
      const char *devnamestr = NULL;
#line 4734 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::open_console() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = (virStreamPtr)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Sys::Virt::Domain::open_console() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 2582 "Virt.xs"
      if (SvOK(devname))
          devnamestr = SvPV_nolen(devname);

      if (virDomainOpenConsole(dom, devnamestr, st, flags) < 0)
          _croak_error();
#line 4761 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_open_graphics); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_open_graphics)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, idx, fd, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	idx = (unsigned int)SvUV(ST(1));
	int	fd = (int)SvIV(ST(2));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::open_graphics() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 2596 "Virt.xs"
      if (virDomainOpenGraphics(dom, idx, fd, flags) < 0)
          _croak_error();
#line 4801 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_screenshot); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_screenshot)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, st, screen, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	virStreamPtr	st;
	unsigned int	screen = (unsigned int)SvUV(ST(2));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::screenshot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = (virStreamPtr)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Sys::Virt::Domain::screenshot() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 2607 "Virt.xs"
      if (virDomainScreenshot(dom, st, screen, flags) < 0)
          _croak_error();
#line 4848 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_block_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_block_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, dev, flags=0");
    {
	virDomainPtr	dom;
	const char *	dev = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
#line 2617 "Virt.xs"
      virDomainBlockInfo info;
#line 4871 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_block_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 2619 "Virt.xs"
      if (virDomainGetBlockInfo(dom, dev, &info, flags) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
      (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
      (void)hv_store (RETVAL, "physical", 8, virt_newSVull(info.physical), 0);
#line 4894 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_job_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_job_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 2634 "Virt.xs"
      virDomainJobInfo info;
#line 4916 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_job_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2636 "Virt.xs"
      if (virDomainGetJobInfo(dom, &info) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "type", 4, newSViv(info.type), 0);
      (void)hv_store (RETVAL, "timeElapsed", 11, virt_newSVull(info.timeElapsed), 0);
      (void)hv_store (RETVAL, "timeRemaining", 13, virt_newSVull(info.timeRemaining), 0);
      (void)hv_store (RETVAL, "dataTotal", 9, virt_newSVull(info.dataTotal), 0);
      (void)hv_store (RETVAL, "dataProcessed", 13, virt_newSVull(info.dataProcessed), 0);
      (void)hv_store (RETVAL, "dataRemaining", 13, virt_newSVull(info.dataRemaining), 0);
      (void)hv_store (RETVAL, "memTotal", 8, virt_newSVull(info.memTotal), 0);
      (void)hv_store (RETVAL, "memProcessed", 12, virt_newSVull(info.memProcessed), 0);
      (void)hv_store (RETVAL, "memRemaining", 12, virt_newSVull(info.memRemaining), 0);
      (void)hv_store (RETVAL, "fileTotal", 9, virt_newSVull(info.fileTotal), 0);
      (void)hv_store (RETVAL, "fileProcessed", 13, virt_newSVull(info.fileProcessed), 0);
      (void)hv_store (RETVAL, "fileRemaining", 13, virt_newSVull(info.fileRemaining), 0);
#line 4942 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_abort_job); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_abort_job)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::abort_job() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2660 "Virt.xs"
      if (virDomainAbortJob(dom) < 0)
          _croak_error();
#line 4974 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_abort_block_job); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_abort_block_job)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, path, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::abort_block_job() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 2670 "Virt.xs"
      if (virDomainBlockJobAbort(dom, path, flags) < 0)
          _croak_error();
#line 5013 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_block_job_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_block_job_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, path, flags=0");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
#line 2680 "Virt.xs"
      virDomainBlockJobInfo info;
#line 5036 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_block_job_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 2682 "Virt.xs"
      if (virDomainGetBlockJobInfo(dom, path, &info, flags) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "type", 4, newSViv(info.type), 0);
      (void)hv_store (RETVAL, "bandwidth", 9, virt_newSVull(info.bandwidth), 0);
      (void)hv_store (RETVAL, "cur", 3, virt_newSVull(info.cur), 0);
      (void)hv_store (RETVAL, "end", 3, virt_newSVull(info.end), 0);
#line 5060 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_block_job_speed); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_block_job_speed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, path, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
	unsigned long	bandwidth = (unsigned long)SvUV(ST(2));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_block_job_speed() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 2701 "Virt.xs"
      if (virDomainBlockJobSetSpeed(dom, path, bandwidth, flags) < 0)
          _croak_error();
#line 5101 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_block_pull); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_block_pull)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, path, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
	unsigned long	bandwidth = (unsigned long)SvUV(ST(2));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::block_pull() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 2712 "Virt.xs"
      if (virDomainBlockPull(dom, path, bandwidth, flags) < 0)
          _croak_error();
#line 5141 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_block_rebase); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_block_rebase)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "dom, path, base, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
	const char *	base = (const char *)SvPV_nolen(ST(2));
	unsigned long	bandwidth = (unsigned long)SvUV(ST(3));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::block_rebase() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4));
	}
#line 2724 "Virt.xs"
      if (virDomainBlockRebase(dom, path, base, bandwidth, flags) < 0)
          _croak_error();
#line 5182 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_disk_errors); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_disk_errors)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 2733 "Virt.xs"
      virDomainDiskErrorPtr errors;
      unsigned int maxerrors;
      int ret;
      int i;
#line 5209 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_disk_errors() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 2738 "Virt.xs"
      if ((ret = virDomainGetDiskErrors(dom, NULL, 0, 0)) < 0)
          _croak_error();
      maxerrors = ret;
      Newx(errors, maxerrors, virDomainDiskError);
      if ((ret = virDomainGetDiskErrors(dom, errors, maxerrors, flags)) < 0) {
          Safefree(errors);
          _croak_error();
      }
      EXTEND(SP, ret);
      for (i = 0 ; i < ret ; i++) {
          HV *rec = newHV();
          (void)hv_store(rec, "path", 4, newSVpv(errors[i].disk, 0), 0);
          (void)hv_store(rec, "error", 5, newSViv(errors[i].error), 0);
          PUSHs(newRV_noinc((SV *)rec));
      }

      Safefree(errors);
#line 5241 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_scheduler_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_scheduler_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 2762 "Virt.xs"
      virTypedParameter *params;
      int nparams;
      char *type;
#line 5265 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_scheduler_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 2766 "Virt.xs"
      if (!(type = virDomainGetSchedulerType(dom, &nparams)))
          _croak_error();

      free(type);
      Newx(params, nparams, virTypedParameter);
      if (flags) {
          if (virDomainGetSchedulerParametersFlags(dom, params, &nparams, flags) < 0) {
              Safefree(params);
              _croak_error();
          }
      } else {
          if (virDomainGetSchedulerParameters(dom, params, &nparams) < 0) {
              Safefree(params);
              _croak_error();
          }
      }
      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 5299 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_scheduler_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_scheduler_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
	unsigned int	flags;
#line 2794 "Virt.xs"
      virTypedParameter *params;
      int nparams;
      char *type;
#line 5327 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_scheduler_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1)))==SVt_PVHV)
	    newparams = (HV*)SvRV(ST(1));
	else
	    Perl_croak(aTHX_ "%s: %s is not a hash reference",
			"Sys::Virt::Domain::set_scheduler_parameters",
			"newparams");

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 2798 "Virt.xs"
      if (!(type = virDomainGetSchedulerType(dom, &nparams)))
          _croak_error();

      free(type);
      Newx(params, nparams, virTypedParameter);
      if (flags) {
          if (virDomainGetSchedulerParametersFlags(dom, params, &nparams, flags) < 0) {
              Safefree(params);
              _croak_error();
          }
      } else {
          if (virDomainGetSchedulerParameters(dom, params, &nparams) < 0) {
              Safefree(params);
              _croak_error();
          }
      }
      vir_typed_param_from_hv(newparams, params, nparams);
      if (flags) {
          if (virDomainSetSchedulerParametersFlags(dom, params, nparams, flags) < 0)
              _croak_error();
      } else {
          if (virDomainSetSchedulerParameters(dom, params, nparams) < 0)
              _croak_error();
      }
      Safefree(params);
#line 5374 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_memory_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_memory_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 2829 "Virt.xs"
      virMemoryParameter *params;
      int nparams;
#line 5396 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_memory_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2832 "Virt.xs"
      nparams = 0;
      if (virDomainGetMemoryParameters(dom, NULL, &nparams, 0) < 0)
          _croak_error();

      Newx(params, nparams, virMemoryParameter);

      if (virDomainGetMemoryParameters(dom, params, &nparams, 0) < 0) {
          Safefree(params);
          _croak_error();
      }

      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 5419 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_memory_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_memory_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, newparams");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
#line 2854 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 5445 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_memory_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1)))==SVt_PVHV)
	    newparams = (HV*)SvRV(ST(1));
	else
	    Perl_croak(aTHX_ "%s: %s is not a hash reference",
			"Sys::Virt::Domain::set_memory_parameters",
			"newparams");
#line 2857 "Virt.xs"
      nparams = 0;
      if (virDomainGetMemoryParameters(dom, NULL, &nparams, 0) < 0)
          _croak_error();

      Newx(params, nparams, virMemoryParameter);

      if (virDomainGetMemoryParameters(dom, params, &nparams, 0) < 0) {
          Safefree(params);
          _croak_error();
      }

      vir_typed_param_from_hv(newparams, params, nparams);

      if (virDomainSetMemoryParameters(dom, params, nparams, 0) < 0)
          _croak_error();
      Safefree(params);
#line 5477 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_numa_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_numa_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 2879 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 5499 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_numa_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2882 "Virt.xs"
      nparams = 0;
      if (virDomainGetNumaParameters(dom, NULL, &nparams, 0) < 0)
          _croak_error();

      Newx(params, nparams, virTypedParameter);

      if (virDomainGetNumaParameters(dom, params, &nparams, 0) < 0) {
          Safefree(params);
          _croak_error();
      }

      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 5522 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_numa_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_numa_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, newparams");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
#line 2904 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 5548 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_numa_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1)))==SVt_PVHV)
	    newparams = (HV*)SvRV(ST(1));
	else
	    Perl_croak(aTHX_ "%s: %s is not a hash reference",
			"Sys::Virt::Domain::set_numa_parameters",
			"newparams");
#line 2907 "Virt.xs"
      nparams = 0;
      if (virDomainGetNumaParameters(dom, NULL, &nparams, 0) < 0)
          _croak_error();

      Newx(params, nparams, virTypedParameter);

      if (virDomainGetNumaParameters(dom, params, &nparams, 0) < 0) {
          Safefree(params);
          _croak_error();
      }

      vir_typed_param_from_hv(newparams, params, nparams);

      if (virDomainSetNumaParameters(dom, params, nparams, 0) < 0)
          _croak_error();
      Safefree(params);
#line 5580 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_blkio_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_blkio_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 2929 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 5602 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_blkio_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2932 "Virt.xs"
      nparams = 0;
      if (virDomainGetBlkioParameters(dom, NULL, &nparams, 0) < 0)
          _croak_error();

      Newx(params, nparams, virBlkioParameter);

      if (virDomainGetBlkioParameters(dom, params, &nparams, 0) < 0) {
          Safefree(params);
          _croak_error();
      }

      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 5625 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_blkio_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_blkio_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, newparams");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
#line 2954 "Virt.xs"
      virTypedParameter *params;
      int nparams;
      int needString;
#line 5652 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_blkio_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1)))==SVt_PVHV)
	    newparams = (HV*)SvRV(ST(1));
	else
	    Perl_croak(aTHX_ "%s: %s is not a hash reference",
			"Sys::Virt::Domain::set_blkio_parameters",
			"newparams");
#line 2958 "Virt.xs"
      nparams = 0;
      if (virDomainGetBlkioParameters(dom, NULL, &nparams, 0) < 0)
          _croak_error();

      Newx(params, nparams, virBlkioParameter);

      if (virDomainGetBlkioParameters(dom, params, &nparams, 0) < 0) {
          Safefree(params);
          _croak_error();
      }

      needString = vir_typed_param_from_hv(newparams, params, nparams);

      if (virDomainSetBlkioParameters(dom, params, nparams,
                                      needString ? VIR_TYPED_PARAM_STRING_OKAY: 0) < 0)
          _croak_error();
      Safefree(params);
#line 5685 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_max_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_max_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_max_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2981 "Virt.xs"
      if (!(RETVAL = virDomainGetMaxMemory(dom)))
          _croak_error();
#line 5716 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_max_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_max_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	val = (unsigned long)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_max_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2992 "Virt.xs"
      if (virDomainSetMaxMemory(dom, val) < 0)
	_croak_error();
#line 5748 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_set_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, val, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	val = (unsigned long)SvUV(ST(1));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 3002 "Virt.xs"
      if (flags) {
          if (virDomainSetMemoryFlags(dom, val, flags) < 0)
              _croak_error();
      } else {
          if (virDomainSetMemory(dom, val) < 0)
              _croak_error();
      }
#line 5792 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_max_vcpus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_max_vcpus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_max_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3015 "Virt.xs"
      if (!(RETVAL = virDomainGetMaxVcpus(dom)))
          _croak_error();
#line 5823 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_vcpus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_vcpus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, num, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	num = (int)SvIV(ST(1));
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2));
	}
#line 3027 "Virt.xs"
      if (flags) {
          if (virDomainSetVcpusFlags(dom, num, flags) < 0)
              _croak_error();
      } else {
          if (virDomainSetVcpus(dom, num) < 0)
              _croak_error();
      }
#line 5867 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_vcpus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_vcpus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}
#line 3041 "Virt.xs"
    if ((RETVAL = virDomainGetVcpusFlags(dom, flags)) < 0)
        _croak_error();
#line 5905 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	autostart = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_autostart() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3052 "Virt.xs"
      if (virDomainSetAutostart(dom, autostart) < 0)
          _croak_error();
#line 5937 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 3060 "Virt.xs"
      int autostart;
#line 5958 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_autostart() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3062 "Virt.xs"
      if (virDomainGetAutostart(dom, &autostart) < 0)
          _croak_error();
      RETVAL = autostart;
#line 5972 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_scheduler_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_scheduler_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 3073 "Virt.xs"
      int nparams;
#line 5993 "Virt.c"
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_scheduler_type() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3075 "Virt.xs"
      if ((RETVAL = virDomainGetSchedulerType(dom, &nparams)) == NULL)
          _croak_error();
#line 6006 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_os_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_os_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 3085 "Virt.xs"
      char *type;
#line 6027 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_os_type() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3087 "Virt.xs"
      if (!(type = virDomainGetOSType(dom)))
          _croak_error();

      RETVAL = newSVpv(type, 0);
      free(type);
#line 6042 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3101 "Virt.xs"
      char *xml;
#line 6065 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_xml_description() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3103 "Virt.xs"
      if (!(xml = virDomainGetXMLDesc(dom, flags)))
          _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 6086 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_shutdown); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_shutdown)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::shutdown() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3117 "Virt.xs"
      if (flags) {
          if (virDomainShutdownFlags(dom, flags) < 0)
              _croak_error();
      } else {
          if (virDomainShutdown(dom) < 0)
              _croak_error();
      }
#line 6130 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_reboot); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_reboot)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::reboot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3131 "Virt.xs"
      if (virDomainReboot(dom, flags) < 0)
          _croak_error();
#line 6168 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_pm_suspend_for_duration); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_pm_suspend_for_duration)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "dom, target, duration, flags");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	target = (unsigned int)SvUV(ST(1));
	SV *	duration = ST(2);
	unsigned int	flags = (unsigned int)SvUV(ST(3));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::pm_suspend_for_duration() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3142 "Virt.xs"
      if (virDomainPMSuspendForDuration(dom, target, virt_SvIVull(duration), flags) < 0)
          _croak_error();
#line 6202 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_reset); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_reset)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::reset() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3151 "Virt.xs"
      if (virDomainReset(dom, flags) < 0)
          _croak_error();
#line 6240 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_inject_nmi); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_inject_nmi)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::inject_nmi() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3160 "Virt.xs"
      if (virDomainInjectNMI(dom, flags) < 0)
          _croak_error();
#line 6278 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::undefine() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3169 "Virt.xs"
      if (flags) {
          if (virDomainUndefineFlags(dom, flags) < 0)
              _croak_error();
      } else {
          if (virDomainUndefine(dom) < 0)
              _croak_error();
      }
#line 6321 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::create() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3183 "Virt.xs"
      if (flags) {
          if (virDomainCreateWithFlags(dom, flags) < 0)
              _croak_error();
      } else {
          if (virDomainCreate(dom) < 0)
              _croak_error();
      }
#line 6364 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_migrate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_migrate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 6)
       croak_xs_usage(cv,  "dom, destcon, flags=0, dname=&PL_sv_undef, uri=&PL_sv_undef, bandwidth=0");
    {
	virDomainPtr	dom;
	virConnectPtr	destcon;
	unsigned long	flags;
	SV *	dname;
	SV *	uri;
	unsigned long	bandwidth;
#line 3201 "Virt.xs"
     const char *dnamestr = NULL;
     const char *uristr = NULL;
#line 6391 "Virt.c"
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::migrate() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        destcon = (virConnectPtr)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Sys::Virt::Domain::migrate() -- destcon is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2));
	}

	if (items < 4)
	    dname = &PL_sv_undef;
	else {
	    dname = ST(3);
	}

	if (items < 5)
	    uri = &PL_sv_undef;
	else {
	    uri = ST(4);
	}

	if (items < 6)
	    bandwidth = 0;
	else {
	    bandwidth = (unsigned long)SvUV(ST(5));
	}
#line 3204 "Virt.xs"
     if (SvOK(dname))
         dnamestr = SvPV_nolen(dname);
     if (SvOK(uri))
         uristr = SvPV_nolen(uri);

     if ((RETVAL = virDomainMigrate(dom, destcon, flags, dnamestr, uristr, bandwidth)) == NULL)
         _croak_error();
#line 6439 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_migrate_to_uri); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_migrate_to_uri)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 5)
       croak_xs_usage(cv,  "dom, desturi, flags=0, dname=&PL_sv_undef, bandwidth=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	desturi = (const char *)SvPV_nolen(ST(1));
	unsigned long	flags;
	SV *	dname;
	unsigned long	bandwidth;
#line 3223 "Virt.xs"
     const char *dnamestr = NULL;
#line 6468 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::migrate_to_uri() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2));
	}

	if (items < 4)
	    dname = &PL_sv_undef;
	else {
	    dname = ST(3);
	}

	if (items < 5)
	    bandwidth = 0;
	else {
	    bandwidth = (unsigned long)SvUV(ST(4));
	}
#line 3225 "Virt.xs"
     if (SvOK(dname))
         dnamestr = SvPV_nolen(dname);

     if (virDomainMigrateToURI(dom, desturi, flags, dnamestr, bandwidth) < 0)
         _croak_error();
#line 6500 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_migrate2); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_migrate2)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 7)
       croak_xs_usage(cv,  "dom, destcon, dxml=&PL_sv_undef, flags=0, dname=&PL_sv_undef, uri=&PL_sv_undef, bandwidth=0");
    {
	virDomainPtr	dom;
	virConnectPtr	destcon;
	SV *	dxml;
	unsigned long	flags;
	SV *	dname;
	SV *	uri;
	unsigned long	bandwidth;
#line 3242 "Virt.xs"
     const char *dnamestr = NULL;
     const char *uristr = NULL;
     const char *dxmlstr = NULL;
#line 6529 "Virt.c"
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::migrate2() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        destcon = (virConnectPtr)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Sys::Virt::Domain::migrate2() -- destcon is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    dxml = &PL_sv_undef;
	else {
	    dxml = ST(2);
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3));
	}

	if (items < 5)
	    dname = &PL_sv_undef;
	else {
	    dname = ST(4);
	}

	if (items < 6)
	    uri = &PL_sv_undef;
	else {
	    uri = ST(5);
	}

	if (items < 7)
	    bandwidth = 0;
	else {
	    bandwidth = (unsigned long)SvUV(ST(6));
	}
#line 3246 "Virt.xs"
     if (SvOK(dxml))
         dxmlstr = SvPV_nolen(dxml);
     if (SvOK(dname))
         dnamestr = SvPV_nolen(dname);
     if (SvOK(uri))
         uristr = SvPV_nolen(uri);

     if ((RETVAL = virDomainMigrate2(dom, destcon, dxmlstr,
                                     flags, dnamestr, uristr, bandwidth)) == NULL)
       _croak_error();
#line 6586 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_migrate_to_uri2); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_migrate_to_uri2)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 7)
       croak_xs_usage(cv,  "dom, dconnuri, miguri=&PL_sv_undef, dxml=&PL_sv_undef, flags=0, dname=&PL_sv_undef, bandwidth=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	dconnuri = (const char *)SvPV_nolen(ST(1));
	SV *	miguri;
	SV *	dxml;
	unsigned long	flags;
	SV *	dname;
	unsigned long	bandwidth;
#line 3270 "Virt.xs"
     const char *miguristr = NULL;
     const char *dxmlstr = NULL;
     const char *dnamestr = NULL;
#line 6619 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::migrate_to_uri2() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    miguri = &PL_sv_undef;
	else {
	    miguri = ST(2);
	}

	if (items < 4)
	    dxml = &PL_sv_undef;
	else {
	    dxml = ST(3);
	}

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4));
	}

	if (items < 6)
	    dname = &PL_sv_undef;
	else {
	    dname = ST(5);
	}

	if (items < 7)
	    bandwidth = 0;
	else {
	    bandwidth = (unsigned long)SvUV(ST(6));
	}
#line 3274 "Virt.xs"
     if (SvOK(dxml))
         dxmlstr = SvPV_nolen(dxml);
     if (SvOK(miguri))
         miguristr = SvPV_nolen(miguri);
     if (SvOK(dname))
         dnamestr = SvPV_nolen(dname);

     if (virDomainMigrateToURI2(dom, dconnuri, miguristr, dxmlstr,
                                flags, dnamestr, bandwidth) < 0)
         _croak_error();
#line 6668 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_migrate_set_max_downtime); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_migrate_set_max_downtime)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, downtime, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	downtime = ST(1);
	unsigned int	flags;
#line 3292 "Virt.xs"
     unsigned long long downtimeVal;
#line 6693 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::migrate_set_max_downtime() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 3294 "Virt.xs"
     downtimeVal = virt_SvIVull(downtime);
     if (virDomainMigrateSetMaxDowntime(dom, downtimeVal, flags) < 0)
         _croak_error();
#line 6711 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_migrate_set_max_speed); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_migrate_set_max_speed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	bandwidth = (unsigned long)SvUV(ST(1));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::migrate_set_max_speed() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 3305 "Virt.xs"
     if (virDomainMigrateSetMaxSpeed(dom, bandwidth, flags) < 0)
         _croak_error();
#line 6750 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_migrate_get_max_speed); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_migrate_get_max_speed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3314 "Virt.xs"
      unsigned long speed;
#line 6772 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::migrate_get_max_speed() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3316 "Virt.xs"
      if (virDomainMigrateGetMaxSpeed(dom, &speed, flags) < 0)
          _croak_error();

      RETVAL = speed;
#line 6793 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_attach_device); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_attach_device)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::attach_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 3330 "Virt.xs"
      if (flags) {
          if (virDomainAttachDeviceFlags(dom, xml, flags) < 0)
              _croak_error();
      } else {
          if (virDomainAttachDevice(dom, xml) < 0)
              _croak_error();
      }
#line 6837 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_detach_device); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_detach_device)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::detach_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 3345 "Virt.xs"
      if (flags) {
          if (virDomainDetachDeviceFlags(dom, xml, flags) < 0)
              _croak_error();
      } else {
          if (virDomainDetachDevice(dom, xml) < 0)
              _croak_error();
      }
#line 6881 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_update_device); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_update_device)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::update_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 3360 "Virt.xs"
      if (virDomainUpdateDeviceFlags(dom, xml, flags) < 0)
          _croak_error();
#line 6920 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_block_iotune); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_block_iotune)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, disk, flags=0");
    {
	virDomainPtr	dom;
	const char *	disk = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
#line 3370 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 6944 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_block_iotune() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 3373 "Virt.xs"
      nparams = 0;
      RETVAL = NULL;
      if (virDomainGetBlockIoTune(dom, disk, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virTypedParameter);
      if (virDomainGetBlockIoTune(dom, disk, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 6973 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_block_iotune); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_block_iotune)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, disk, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	disk = (const char *)SvPV_nolen(ST(1));
	HV *	newparams;
	unsigned int	flags;
#line 3397 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 7001 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_block_iotune() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (SvROK(ST(2)) && SvTYPE(SvRV(ST(2)))==SVt_PVHV)
	    newparams = (HV*)SvRV(ST(2));
	else
	    Perl_croak(aTHX_ "%s: %s is not a hash reference",
			"Sys::Virt::Domain::set_block_iotune",
			"newparams");

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 3400 "Virt.xs"
      nparams = 0;
      if (virDomainGetBlockIoTune(dom, disk, NULL, &nparams, flags) < 0)
          _croak_error();
      Newx(params, nparams, virTypedParameter);

      if (virDomainGetBlockIoTune(dom, disk, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      vir_typed_param_from_hv(newparams, params, nparams);
      if (virDomainSetBlockIoTune(dom, disk, params, nparams, flags) < 0)
          _croak_error();
#line 7036 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_interface_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_interface_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, intf, flags=0");
    {
	virDomainPtr	dom;
	const char *	intf = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
#line 3421 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 7060 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_interface_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 3424 "Virt.xs"
      nparams = 0;
      RETVAL = NULL;
      if (virDomainGetInterfaceParameters(dom, intf, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virTypedParameter);
      if (virDomainGetInterfaceParameters(dom, intf, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 7089 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_interface_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_interface_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, intf, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	intf = (const char *)SvPV_nolen(ST(1));
	HV *	newparams;
	unsigned int	flags;
#line 3448 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 7117 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_interface_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (SvROK(ST(2)) && SvTYPE(SvRV(ST(2)))==SVt_PVHV)
	    newparams = (HV*)SvRV(ST(2));
	else
	    Perl_croak(aTHX_ "%s: %s is not a hash reference",
			"Sys::Virt::Domain::set_interface_parameters",
			"newparams");

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 3451 "Virt.xs"
      nparams = 0;
      if (virDomainGetInterfaceParameters(dom, intf, NULL, &nparams, flags) < 0)
          _croak_error();
      Newx(params, nparams, virTypedParameter);

      if (virDomainGetInterfaceParameters(dom, intf, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      vir_typed_param_from_hv(newparams, params, nparams);
      if (virDomainSetInterfaceParameters(dom, intf, params, nparams, flags) < 0)
          _croak_error();
#line 7152 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_block_stats); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_block_stats)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, path, flags=0");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
#line 3472 "Virt.xs"
      virDomainBlockStatsStruct stats;
      virTypedParameter *params;
      int nparams;
      unsigned int i;
      const char *field;
#line 7179 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::block_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 3478 "Virt.xs"
      nparams = 0;
      RETVAL = NULL;
      if (virDomainBlockStatsFlags(dom, path, NULL, &nparams, flags) < 0) {
          virErrorPtr err = virGetLastError();
          if (err && err->code == VIR_ERR_NO_SUPPORT && !flags) {
              if (virDomainBlockStats(dom, path, &stats, sizeof(stats)) < 0)
                  _croak_error();

              RETVAL = (HV *)sv_2mortal((SV*)newHV());
              (void)hv_store (RETVAL, "rd_req", 6, virt_newSVll(stats.rd_req), 0);
              (void)hv_store (RETVAL, "rd_bytes", 8, virt_newSVll(stats.rd_bytes), 0);
              (void)hv_store (RETVAL, "wr_req", 6, virt_newSVll(stats.wr_req), 0);
              (void)hv_store (RETVAL, "wr_bytes", 8, virt_newSVll(stats.wr_bytes), 0);
              (void)hv_store (RETVAL, "errs", 4, virt_newSVll(stats.errs), 0);
          } else {
              _croak_error();
          }
      } else {
          Newx(params, nparams, virTypedParameter);

          if (virDomainBlockStatsFlags(dom, path, params, &nparams, flags) < 0) {
              Safefree(params);
              _croak_error();
          }

          RETVAL = vir_typed_param_to_hv(params, nparams);
          for (i = 0 ; i < nparams ; i++) {
              field = NULL;
              /* For back compat with previous hash above */
              if (strcmp(params[i].field, "rd_operations") == 0)
                  field = "rd_reqs";
              else if (strcmp(params[i].field, "wr_operations") == 0)
                  field = "wr_reqs";
              else if (strcmp(params[i].field, "flush_operations") == 0)
                  field = "flush_reqs";
              if (field) {
                  SV *val = hv_delete(RETVAL, params[i].field, strlen(params[i].field), 0);
                  SvREFCNT_inc(val);
                  (void)hv_store(RETVAL, field, strlen(field), val, 0);
              }
          }
          Safefree(params);
      }
#line 7238 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_interface_stats); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_interface_stats)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, path");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
#line 3530 "Virt.xs"
      virDomainInterfaceStatsStruct stats;
#line 7261 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::interface_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3532 "Virt.xs"
      if (virDomainInterfaceStats(dom, path, &stats, sizeof(stats)) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "rx_bytes", 8, virt_newSVll(stats.rx_bytes), 0);
      (void)hv_store (RETVAL, "rx_packets", 10, virt_newSVll(stats.rx_packets), 0);
      (void)hv_store (RETVAL, "rx_errs", 7, virt_newSVll(stats.rx_errs), 0);
      (void)hv_store (RETVAL, "rx_drop", 7, virt_newSVll(stats.rx_drop), 0);
      (void)hv_store (RETVAL, "tx_bytes", 8, virt_newSVll(stats.tx_bytes), 0);
      (void)hv_store (RETVAL, "tx_packets", 10, virt_newSVll(stats.tx_packets), 0);
      (void)hv_store (RETVAL, "tx_errs", 7, virt_newSVll(stats.tx_errs), 0);
      (void)hv_store (RETVAL, "tx_drop", 7, virt_newSVll(stats.tx_drop), 0);
#line 7283 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_memory_stats); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_memory_stats)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3553 "Virt.xs"
      virDomainMemoryStatPtr stats;
      int i, got;
#line 7307 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::memory_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3556 "Virt.xs"
      Newx(stats, VIR_DOMAIN_MEMORY_STAT_NR, virDomainMemoryStatStruct);
      if ((got = virDomainMemoryStats(dom, stats, VIR_DOMAIN_MEMORY_STAT_NR, flags)) < 0) {
          Safefree(stats);
          _croak_error();
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      for (i = 0 ; i < got ; i++) {
          switch (stats[i].tag) {
          case VIR_DOMAIN_MEMORY_STAT_SWAP_IN:
              (void)hv_store (RETVAL, "swap_in", 7, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_SWAP_OUT:
              (void)hv_store (RETVAL, "swap_out", 8, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_MAJOR_FAULT:
              (void)hv_store (RETVAL, "major_fault", 11, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_MINOR_FAULT:
              (void)hv_store (RETVAL, "minor_fault", 11, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_UNUSED:
              (void)hv_store (RETVAL, "unused", 6, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_AVAILABLE:
              (void)hv_store (RETVAL, "available", 9, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_ACTUAL_BALLOON:
              (void)hv_store (RETVAL, "actual_balloon", 14, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_RSS:
              (void)hv_store (RETVAL, "rss", 14, virt_newSVll(stats[i].val), 0);
              break;
          }
      }
      Safefree(stats);
#line 7365 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_send_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_send_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "dom, codeset, holdtime, keycodesSV, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	codeset = (unsigned int)SvUV(ST(1));
	unsigned int	holdtime = (unsigned int)SvUV(ST(2));
	SV *	keycodesSV = ST(3);
	unsigned int	flags;
#line 3610 "Virt.xs"
      AV *keycodesAV;
      unsigned int *keycodes;
      int nkeycodes;
      int i;
#line 7396 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::send_key() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4));
	}
#line 3615 "Virt.xs"
      if (!SvROK(keycodesSV))
          return;
      keycodesAV = (AV*)SvRV(keycodesSV);
      nkeycodes = av_len(keycodesAV) + 1;
      Newx(keycodes, nkeycodes, unsigned int);

      for (i = 0 ; i < nkeycodes ; i++) {
          SV **code = av_fetch(keycodesAV, i, 0);
          keycodes[i] = SvIV(*code);
      }

      if (virDomainSendKey(dom, codeset, holdtime, keycodes, nkeycodes, flags) < 0) {
          Safefree(keycodes);
          _croak_error();
      }

      Safefree(keycodes);
#line 7428 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_block_resize); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_block_resize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, disk, size, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	disk = (const char *)SvPV_nolen(ST(1));
	SV *	size = ST(2);
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::block_resize() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 3641 "Virt.xs"
      if (virDomainBlockResize(dom, disk, virt_SvIVull(size), flags) < 0)
          _croak_error();
#line 7468 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_block_peek); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_block_peek)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "dom, path, offset, size, flags=0");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
	unsigned int	offset = (unsigned int)SvUV(ST(2));
	size_t	size = (size_t)SvUV(ST(3));
	unsigned int	flags;
#line 3653 "Virt.xs"
      char *buf;
#line 7493 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::block_peek() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4));
	}
#line 3655 "Virt.xs"
      Newx(buf, size, char);
      if (virDomainBlockPeek(dom, path, offset, size, buf, flags) < 0) {
          Safefree(buf);
          _croak_error();
      }
      RETVAL = newSVpvn(buf, size);
#line 7515 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_memory_peek); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_memory_peek)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, offset, size, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	offset = (unsigned int)SvUV(ST(1));
	size_t	size = (size_t)SvUV(ST(2));
	unsigned int	flags;
#line 3672 "Virt.xs"
      char *buf;
#line 7540 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::memory_peek() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 3674 "Virt.xs"
      Newx(buf, size, char);
      if (virDomainMemoryPeek(dom, offset, size, buf, flags) < 0) {
          Safefree(buf);
          _croak_error();
      }
      RETVAL = newSVpvn(buf, size);
#line 7562 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_security_label); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_security_label)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 3688 "Virt.xs"
      virSecurityLabel seclabel;
#line 7584 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_security_label() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3690 "Virt.xs"
      if (virDomainGetSecurityLabel(dom, &seclabel) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "label", 5, newSVpv(seclabel.label, 0), 0);
      (void)hv_store (RETVAL, "enforcing", 9, newSViv(seclabel.enforcing), 0);
#line 7600 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_cpu_stats); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_cpu_stats)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, start_cpu, ncpus, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	start_cpu = (int)SvIV(ST(1));
	unsigned int	ncpus = (unsigned int)SvUV(ST(2));
	unsigned int	flags;
#line 3707 "Virt.xs"
      virTypedParameterPtr params;
      unsigned int nparams;
      int ret;
      int i;
#line 7630 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_cpu_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 3712 "Virt.xs"
      if ((ret = virDomainGetCPUStats(dom, NULL, 0, 0, 1, 0)) < 0)
          _croak_error();
      nparams = ret;

      if (ncpus == 0) {
          if ((ret = virDomainGetCPUStats(dom, NULL, 0, 0, 0, 0)) < 0)
              _croak_error();
          ncpus = ret;
      }

      Newx(params, ncpus * nparams, virTypedParameter);
      if ((ret = virDomainGetCPUStats(dom, params, nparams, start_cpu, ncpus, flags)) < 0) {
          Safefree(params);
          _croak_error();
      }

      EXTEND(SP, ret);
      for (i = 0 ; i < ret ; i++) {
          HV *rec = vir_typed_param_to_hv(params + (i * nparams), nparams);
          PUSHs(newRV_noinc((SV *)rec));
      }

      Safefree(params);
#line 7668 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_vcpu_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_vcpu_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3742 "Virt.xs"
      virVcpuInfoPtr info;
      unsigned char *cpumaps;
      int maplen;
      virNodeInfo nodeinfo;
      virDomainInfo dominfo;
      int nvCpus;
      int i;
#line 7698 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_vcpu_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3750 "Virt.xs"
      if (virNodeGetInfo(virDomainGetConnect(dom), &nodeinfo) < 0)
          _croak_error();
      if (virDomainGetInfo(dom, &dominfo) < 0)
          _croak_error();

      maplen = VIR_CPU_MAPLEN(VIR_NODEINFO_MAXCPUS(nodeinfo));
      Newx(cpumaps, dominfo.nrVirtCpu * maplen, unsigned char);
      if (flags && (flags & VIR_DOMAIN_AFFECT_CONFIG)) {
          Newx(info, dominfo.nrVirtCpu, virVcpuInfo);
          if ((nvCpus = virDomainGetVcpus(dom, info, dominfo.nrVirtCpu, cpumaps, maplen)) < 0) {
              Safefree(info);
              Safefree(cpumaps);
              _croak_error();
          }
      } else {
          info = NULL;
          if ((nvCpus = virDomainGetVcpuPinInfo(dom, dominfo.nrVirtCpu, cpumaps, maplen, flags)) < 0) {
              Safefree(cpumaps);
              _croak_error();
          }
      }

      EXTEND(SP, nvCpus);
      for (i = 0 ; i < nvCpus ; i++) {
          HV *rec = newHV();
          (void)hv_store(rec, "number", 6, newSViv(i), 0);
          if (info) {
              (void)hv_store(rec, "state", 5, newSViv(info[i].state), 0);
              (void)hv_store(rec, "cpuTime", 7, virt_newSVull(info[i].cpuTime), 0);
              (void)hv_store(rec, "cpu", 3, newSViv(info[i].cpu), 0);
          }
          (void)hv_store(rec, "affinity", 8, newSVpvn((char*)cpumaps + (i *maplen), maplen), 0);
          PUSHs(newRV_noinc((SV *)rec));
      }

      if (info)
          Safefree(info);
      Safefree(cpumaps);
#line 7751 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_pin_vcpu); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_pin_vcpu)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, vcpu, mask, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	vcpu = (unsigned int)SvUV(ST(1));
	SV *	mask = ST(2);
	unsigned int	flags;
#line 3797 "Virt.xs"
     STRLEN masklen;
     unsigned char *maps;
#line 7778 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::pin_vcpu() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 3800 "Virt.xs"
     maps = (unsigned char *)SvPV(mask, masklen);
     if (flags) {
         if (virDomainPinVcpuFlags(dom, vcpu, maps, masklen, flags) < 0)
             _croak_error();
     } else {
         if (virDomainPinVcpu(dom, vcpu, maps, masklen) < 0)
             _croak_error();
     }
#line 7801 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_num_of_snapshots); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_num_of_snapshots)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::num_of_snapshots() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3815 "Virt.xs"
      if ((RETVAL = virDomainSnapshotNum(dom, flags)) < 0)
          _croak_error();
#line 7839 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_list_snapshot_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_list_snapshot_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, maxnames, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	maxnames = (int)SvIV(ST(1));
	unsigned int	flags;
#line 3827 "Virt.xs"
      char **names;
      int nsnap;
      int i;
#line 7866 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::list_snapshot_names() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 3831 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nsnap = virDomainSnapshotListNames(dom, names, maxnames, flags)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nsnap);
      for (i = 0 ; i < nsnap ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 7892 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_has_current_snapshot); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_has_current_snapshot)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::has_current_snapshot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3849 "Virt.xs"
      if ((RETVAL = virDomainHasCurrentSnapshot(dom, flags)) < 0)
          _croak_error();
#line 7930 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_current_snapshot); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_current_snapshot)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	virDomainSnapshotPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::current_snapshot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3860 "Virt.xs"
      if ((RETVAL = virDomainSnapshotCurrent(dom, flags)) < 0)
          _croak_error();
#line 7967 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::DomainSnapshot", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom_rv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dom_rv = ST(0);
	unsigned int	flags;
#line 3871 "Virt.xs"
      virDomainPtr dom;
#line 7994 "Virt.c"

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 3873 "Virt.xs"
      dom = (virDomainPtr)SvIV((SV*)SvRV(dom_rv));
      if (flags) {
          if (virDomainDestroyFlags(dom, flags) < 0)
              _croak_error();
      } else {
          if (virDomainDestroy(dom) < 0)
              _croak_error();
      }
#line 8010 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dom_rv = ST(0);
#line 3887 "Virt.xs"
      virDomainPtr dom;
#line 8033 "Virt.c"
#line 3889 "Virt.xs"
      dom = (virDomainPtr)SvIV((SV*)SvRV(dom_rv));
      if (dom) {
	virDomainFree(dom);
	sv_setiv((SV*)SvRV(dom_rv), 0);
      }
#line 8040 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3904 "Virt.xs"
      if (!(RETVAL = virNetworkCreateXML(con, xml)))
          _croak_error();
#line 8071 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3915 "Virt.xs"
      if (!(RETVAL = virNetworkDefineXML(con, xml)))
          _croak_error();
#line 8105 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3926 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByName(con, name)))
          _croak_error();
#line 8139 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3937 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByUUID(con, uuid)))
          _croak_error();
#line 8173 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3948 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByUUIDString(con, uuid)))
          _croak_error();

#line 8208 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 3959 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 8232 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_uuid() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3961 "Virt.xs"
      if ((virNetworkGetUUID(net, rawuuid)) < 0)
          _croak_error();

      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 8246 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 3973 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 8268 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_uuid_string() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3975 "Virt.xs"
      if ((virNetworkGetUUIDString(net, uuid)) < 0)
          _croak_error();

      RETVAL = newSVpv(uuid, 0);
#line 8282 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_name() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3987 "Virt.xs"
      if (!(RETVAL = virNetworkGetName(net)))
          _croak_error();
#line 8314 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_is_active); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_is_active)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::is_active() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 3997 "Virt.xs"
      if ((RETVAL = virNetworkIsActive(net)) < 0)
          _croak_error();
#line 8345 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_is_persistent); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_is_persistent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::is_persistent() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4007 "Virt.xs"
      if ((RETVAL = virNetworkIsPersistent(net)) < 0)
          _croak_error();
#line 8376 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_bridge_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_bridge_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 4017 "Virt.xs"
      char *name;
#line 8397 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_bridge_name() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4019 "Virt.xs"
      if (!(name = virNetworkGetBridgeName(net)))
          _croak_error();

      RETVAL = newSVpv(name, 0);
      free(name);
#line 8412 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "net, flags=0");
    {
	virNetworkPtr	net;
	unsigned int	flags;
#line 4033 "Virt.xs"
      char *xml;
#line 8435 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_xml_description() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 4035 "Virt.xs"
      if (!(xml = virNetworkGetXMLDesc(net, flags)))
	 _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 8456 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::undefine() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4048 "Virt.xs"
      if (virNetworkUndefine(net) < 0)
          _croak_error();
#line 8488 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::create() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4056 "Virt.xs"
      if (virNetworkCreate(net) < 0)
          _croak_error();
#line 8519 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_set_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "net, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;
	int	autostart = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::set_autostart() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4065 "Virt.xs"
      if (virNetworkSetAutostart(net, autostart) < 0)
          _croak_error();
#line 8551 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 4073 "Virt.xs"
      int autostart;
#line 8572 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_autostart() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4075 "Virt.xs"
      if (virNetworkGetAutostart(net, &autostart) < 0)
          _croak_error();

      RETVAL = autostart;
#line 8587 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	net_rv = ST(0);
#line 4087 "Virt.xs"
      virNetworkPtr net;
#line 8610 "Virt.c"
#line 4089 "Virt.xs"
      net = (virNetworkPtr)SvIV((SV*)SvRV(net_rv));
      if (virNetworkDestroy(net) < 0)
          _croak_error();
#line 8615 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	net_rv = ST(0);
#line 4098 "Virt.xs"
      virNetworkPtr net;
#line 8638 "Virt.c"
#line 4100 "Virt.xs"
      net = (virNetworkPtr)SvIV((SV*)SvRV(net_rv));
      if (net) {
	virNetworkFree(net);
	sv_setiv((SV*)SvRV(net_rv), 0);
      }
#line 8645 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4115 "Virt.xs"
      if (!(RETVAL = virStoragePoolCreateXML(con, xml, 0)))
          _croak_error();

#line 8677 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4127 "Virt.xs"
      if (!(RETVAL = virStoragePoolDefineXML(con, xml, 0)))
          _croak_error();
#line 8710 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4138 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByName(con, name)))
          _croak_error();
#line 8743 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4149 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByUUID(con, uuid)))
          _croak_error();
#line 8776 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4160 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByUUIDString(con, uuid)))
	_croak_error();
#line 8809 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__lookup_by_volume); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__lookup_by_volume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_volume() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4170 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByVolume(vol)))
          _croak_error();
#line 8841 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 4180 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 8864 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_uuid() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4182 "Virt.xs"
      if ((virStoragePoolGetUUID(pool, rawuuid)) < 0)
          _croak_error();

      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 8878 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 4194 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 8900 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_uuid_string() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4196 "Virt.xs"
      if ((virStoragePoolGetUUIDString(pool, uuid)) < 0)
          _croak_error();

      RETVAL = newSVpv(uuid, 0);
#line 8914 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_name() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4208 "Virt.xs"
      if (!(RETVAL = virStoragePoolGetName(pool)))
          _croak_error();
#line 8946 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_is_active); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_is_active)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::is_active() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4218 "Virt.xs"
      if ((RETVAL = virStoragePoolIsActive(pool)) < 0)
          _croak_error();
#line 8977 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_is_persistent); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_is_persistent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::is_persistent() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4228 "Virt.xs"
      if ((RETVAL = virStoragePoolIsPersistent(pool)) < 0)
          _croak_error();
#line 9008 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    {
	virStoragePoolPtr	pool;
	unsigned int	flags;
#line 4239 "Virt.xs"
      char *xml;
#line 9030 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_xml_description() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 4241 "Virt.xs"
      if (!(xml = virStoragePoolGetXMLDesc(pool, flags)))
          _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 9051 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::undefine() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4254 "Virt.xs"
      if (virStoragePoolUndefine(pool) < 0)
          _croak_error();
#line 9083 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::create() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4262 "Virt.xs"
      if (virStoragePoolCreate(pool, 0) < 0)
          _croak_error();
#line 9114 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_refresh); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_refresh)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::refresh() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}
#line 4271 "Virt.xs"
      if (virStoragePoolRefresh(pool, flags) < 0)
          _croak_error();
#line 9152 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_build); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_build)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::build() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}
#line 4280 "Virt.xs"
      if (virStoragePoolBuild(pool, flags) < 0)
          _croak_error();
#line 9190 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::delete() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}
#line 4289 "Virt.xs"
      if (virStoragePoolDelete(pool, flags) < 0)
          _croak_error();
#line 9228 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_set_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pool, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	autostart = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::set_autostart() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4298 "Virt.xs"
      if (virStoragePoolSetAutostart(pool, autostart) < 0)
          _croak_error();
#line 9260 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 4306 "Virt.xs"
      int autostart;
#line 9281 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_autostart() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4308 "Virt.xs"
      if (virStoragePoolGetAutostart(pool, &autostart) < 0)
          _croak_error();

      RETVAL = autostart;
#line 9296 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 4320 "Virt.xs"
      virStoragePoolInfo info;
#line 9317 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_info() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4322 "Virt.xs"
      if (virStoragePoolGetInfo(pool, &info) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
      (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
      (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
      (void)hv_store (RETVAL, "available", 9, virt_newSVull(info.available), 0);
#line 9335 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	pool_rv = ST(0);
#line 4338 "Virt.xs"
      virStoragePoolPtr pool;
#line 9359 "Virt.c"
#line 4340 "Virt.xs"
      pool = (virStoragePoolPtr)SvIV((SV*)SvRV(pool_rv));
      if (virStoragePoolDestroy(pool) < 0)
          _croak_error();
#line 9364 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_num_of_storage_volumes); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_num_of_storage_volumes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::num_of_storage_volumes() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4349 "Virt.xs"
      if ((RETVAL = virStoragePoolNumOfVolumes(pool)) < 0)
          _croak_error();
#line 9395 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_list_storage_vol_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_list_storage_vol_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pool, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	maxnames = (int)SvIV(ST(1));
#line 4360 "Virt.xs"
      char **names;
      int i, nnet;
#line 9420 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::list_storage_vol_names() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4363 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virStoragePoolListVolumes(pool, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 9440 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	pool_rv = ST(0);
#line 4380 "Virt.xs"
      virStoragePoolPtr pool;
#line 9463 "Virt.c"
#line 4382 "Virt.xs"
      pool = (virStoragePoolPtr)SvIV((SV*)SvRV(pool_rv));
      if (pool) {
          virStoragePoolFree(pool);
          sv_setiv((SV*)SvRV(pool_rv), 0);
      }
#line 9470 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StorageVol__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pool, xml, flags=0");
    {
	virStoragePoolPtr	pool;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	int	flags;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2));
	}
#line 4398 "Virt.xs"
      if (!(RETVAL = virStorageVolCreateXML(pool, xml, flags)))
          _croak_error();
#line 9508 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol__create_xml_from); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__create_xml_from)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "pool, xml, clone, flags=0");
    {
	virStoragePoolPtr	pool;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virStorageVolPtr	clone;
	int	flags;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml_from() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVMG))
        clone = (virStorageVolPtr)SvIV((SV*)SvRV( ST(2) ));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml_from() -- clone is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3));
	}
#line 4411 "Virt.xs"
      if (!(RETVAL = virStorageVolCreateXMLFrom(pool, xml, clone, flags)))
	_croak_error();
#line 9556 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pool, name");
    {
	virStoragePoolPtr	pool;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_name() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4422 "Virt.xs"
      if (!(RETVAL = virStorageVolLookupByName(pool, name)))
          _croak_error();
#line 9589 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol__lookup_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__lookup_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, key");
    {
	virConnectPtr	con;
	const char *	key = (const char *)SvPV_nolen(ST(1));
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_key() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4433 "Virt.xs"
      if (!(RETVAL = virStorageVolLookupByKey(con, key)))
          _croak_error();
#line 9622 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol__lookup_by_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__lookup_by_path)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, path");
    {
	virConnectPtr	con;
	const char *	path = (const char *)SvPV_nolen(ST(1));
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_path() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4444 "Virt.xs"
      if (!(RETVAL = virStorageVolLookupByPath(con, path)))
          _croak_error();
#line 9655 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_name() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4454 "Virt.xs"
      if (!(RETVAL = virStorageVolGetName(vol)))
          _croak_error();
#line 9688 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_get_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_key() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4464 "Virt.xs"
      if (!(RETVAL = virStorageVolGetKey(vol)))
          _croak_error();
#line 9719 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_get_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_path)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_path() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4474 "Virt.xs"
      if (!(RETVAL = virStorageVolGetPath(vol)))
          _croak_error();
#line 9750 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_resize); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_resize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "vol, capacity, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	SV *	capacity = ST(1);
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::resize() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 4486 "Virt.xs"
      if (virStorageVolResize(vol, virt_SvIVull(capacity), flags) < 0)
          _croak_error();
#line 9789 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StorageVol_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "vol, flags=0");
    {
	virStorageVolPtr	vol;
	unsigned int	flags;
#line 4495 "Virt.xs"
      char *xml;
#line 9811 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_xml_description() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 4497 "Virt.xs"
      if (!(xml = virStorageVolGetXMLDesc(vol, flags)))
	 _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 9832 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "vol, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::delete() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 4511 "Virt.xs"
      if (virStorageVolDelete(vol, flags) < 0)
          _croak_error();
#line 9871 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StorageVol_wipe); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_wipe)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "vol, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::wipe() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 4520 "Virt.xs"
      if (virStorageVolWipe(vol, flags) < 0)
          _croak_error();
#line 9909 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StorageVol_wipe_pattern); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_wipe_pattern)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "vol, algorithm, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	unsigned int	algorithm = (unsigned int)SvUV(ST(1));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::wipe_pattern() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 4530 "Virt.xs"
      if (virStorageVolWipePattern(vol, algorithm, flags) < 0)
          _croak_error();
#line 9948 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StorageVol_get_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
#line 4538 "Virt.xs"
      virStorageVolInfo info;
#line 9969 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_info() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4540 "Virt.xs"
      if (virStorageVolGetInfo(vol, &info) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "type", 4, newSViv(info.type), 0);
      (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
      (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
#line 9986 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_download); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_download)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "vol, st, offsetsv, lengthsv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	virStreamPtr	st;
	SV *	offsetsv = ST(2);
	SV *	lengthsv = ST(3);
	unsigned int	flags;
#line 4559 "Virt.xs"
      unsigned long long offset;
      unsigned long long length;
#line 10015 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::download() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = (virStreamPtr)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Sys::Virt::StorageVol::download() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4));
	}
#line 4562 "Virt.xs"
      offset = virt_SvIVull(offsetsv);
      length = virt_SvIVull(lengthsv);

      if (virStorageVolDownload(vol, st, offset, length, flags) < 0)
          _croak_error();
#line 10042 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StorageVol_upload); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_upload)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "vol, st, offsetsv, lengthsv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	virStreamPtr	st;
	SV *	offsetsv = ST(2);
	SV *	lengthsv = ST(3);
	unsigned int	flags;
#line 4577 "Virt.xs"
      unsigned long long offset;
      unsigned long long length;
#line 10070 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::upload() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = (virStreamPtr)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Sys::Virt::StorageVol::upload() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4));
	}
#line 4580 "Virt.xs"
      offset = virt_SvIVull(offsetsv);
      length = virt_SvIVull(lengthsv);

      if (virStorageVolUpload(vol, st, offset, length, flags) < 0)
          _croak_error();
#line 10097 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StorageVol_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	vol_rv = ST(0);
#line 4591 "Virt.xs"
      virStorageVolPtr vol;
#line 10120 "Virt.c"
#line 4593 "Virt.xs"
      vol = (virStorageVolPtr)SvIV((SV*)SvRV(vol_rv));
      if (vol) {
          virStorageVolFree(vol);
          sv_setiv((SV*)SvRV(vol_rv), 0);
      }
#line 10127 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
	virNodeDevicePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 4609 "Virt.xs"
      if (!(RETVAL = virNodeDeviceCreateXML(con, xml, flags)))
          _croak_error();
#line 10165 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NodeDevice", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virNodeDevicePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4620 "Virt.xs"
      if (!(RETVAL = virNodeDeviceLookupByName(con, name)))
          _croak_error();
#line 10200 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NodeDevice", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	virNodeDevicePtr	dev;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::get_name() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4630 "Virt.xs"
      if (!(RETVAL = virNodeDeviceGetName(dev)))
          _croak_error();
#line 10235 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice_get_parent); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_get_parent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	virNodeDevicePtr	dev;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::get_parent() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4640 "Virt.xs"
      if (!(RETVAL = virNodeDeviceGetParent(dev)))
          _croak_error();
#line 10266 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dev, flags=0");
    {
	virNodeDevicePtr	dev;
	unsigned int	flags;
#line 4651 "Virt.xs"
      char *xml;
#line 10288 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::get_xml_description() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 4653 "Virt.xs"
      if (!(xml = virNodeDeviceGetXMLDesc(dev, flags)))
          _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 10309 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice_dettach); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_dettach)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::dettach() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4666 "Virt.xs"
      if (virNodeDeviceDettach(dev) < 0)
          _croak_error();
#line 10341 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_reattach); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_reattach)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::reattach() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4674 "Virt.xs"
      if (virNodeDeviceReAttach(dev) < 0)
	_croak_error();
#line 10372 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_reset); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_reset)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::reset() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4682 "Virt.xs"
      if (virNodeDeviceReset(dev) < 0)
          _croak_error();
#line 10403 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_list_capabilities); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_list_capabilities)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;
#line 4690 "Virt.xs"
      int maxnames;
      char **names;
      int i, nnet;
#line 10428 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::list_capabilities() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4694 "Virt.xs"
      if ((maxnames = virNodeDeviceNumOfCaps(dev)) < 0)
          _croak_error();

      Newx(names, maxnames, char *);
      if ((nnet = virNodeDeviceListCaps(dev, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 10451 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dev_rv = ST(0);
#line 4714 "Virt.xs"
      virNodeDevicePtr dev;
#line 10474 "Virt.c"
#line 4716 "Virt.xs"
      dev = (virNodeDevicePtr)SvIV((SV*)SvRV(dev_rv));
      if (virNodeDeviceDestroy(dev) < 0)
          _croak_error();
#line 10479 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dev_rv = ST(0);
#line 4725 "Virt.xs"
      virNodeDevicePtr dev;
#line 10502 "Virt.c"
#line 4727 "Virt.xs"
      dev = (virNodeDevicePtr)SvIV((SV*)SvRV(dev_rv));
      if (dev) {
          virNodeDeviceFree(dev);
          sv_setiv((SV*)SvRV(dev_rv), 0);
      }
#line 10509 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Interface__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags = 0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
	virInterfacePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 4742 "Virt.xs"
      if (!(RETVAL = virInterfaceDefineXML(con, xml, flags)))
          _croak_error();
#line 10547 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Interface", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virInterfacePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4753 "Virt.xs"
      if (!(RETVAL = virInterfaceLookupByName(con, name)))
          _croak_error();
#line 10581 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Interface", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface__lookup_by_mac); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface__lookup_by_mac)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, mac");
    {
	virConnectPtr	con;
	const char *	mac = (const char *)SvPV_nolen(ST(1));
	virInterfacePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::_lookup_by_mac() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4764 "Virt.xs"
      if (!(RETVAL = virInterfaceLookupByMACString(con, mac)))
          _croak_error();
#line 10615 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Interface", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface_get_mac); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_get_mac)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    {
	virInterfacePtr	iface;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = (virInterfacePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::get_mac() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4774 "Virt.xs"
      if (!(RETVAL = virInterfaceGetMACString(iface)))
          _croak_error();
#line 10649 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    {
	virInterfacePtr	iface;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = (virInterfacePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::get_name() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4784 "Virt.xs"
      if (!(RETVAL = virInterfaceGetName(iface)))
          _croak_error();
#line 10680 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface_is_active); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_is_active)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    {
	virInterfacePtr	iface;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = (virInterfacePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::is_active() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4794 "Virt.xs"
      if ((RETVAL = virInterfaceIsActive(iface)) < 0)
          _croak_error();
#line 10711 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "iface, flags=0");
    {
	virInterfacePtr	iface;
	unsigned int	flags;
#line 4805 "Virt.xs"
      char *xml;
#line 10733 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = (virInterfacePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::get_xml_description() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 4807 "Virt.xs"
      if (!(xml = virInterfaceGetXMLDesc(iface, flags)))
          _croak_error();
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 10753 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virInterfacePtr	iface;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = (virInterfacePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::undefine() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4819 "Virt.xs"
      if (virInterfaceUndefine(iface) < 0)
          _croak_error();
#line 10785 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Interface_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "iface, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virInterfacePtr	iface;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = (virInterfacePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::create() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 4828 "Virt.xs"
      if (virInterfaceCreate(iface, flags) < 0)
          _croak_error();
#line 10823 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Interface_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "iface_rv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	iface_rv = ST(0);
	unsigned int	flags;
#line 4837 "Virt.xs"
      virInterfacePtr iface;
#line 10847 "Virt.c"

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 4839 "Virt.xs"
      iface = (virInterfacePtr)SvIV((SV*)SvRV(iface_rv));
      if (virInterfaceDestroy(iface, flags) < 0)
          _croak_error();
#line 10858 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Interface_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "iface_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	iface_rv = ST(0);
#line 4848 "Virt.xs"
      virInterfacePtr iface;
#line 10881 "Virt.c"
#line 4850 "Virt.xs"
      iface = (virInterfacePtr)SvIV((SV*)SvRV(iface_rv));
      if (iface) {
          virInterfaceFree(iface);
          sv_setiv((SV*)SvRV(iface_rv), 0);
      }
#line 10888 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Secret__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
	virSecretPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Secret::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 4866 "Virt.xs"
      if (!(RETVAL = virSecretDefineXML(con, xml, flags)))
          _croak_error();
#line 10926 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Secret", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Secret__lookup_by_usage); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret__lookup_by_usage)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "con, usageType, usageID");
    {
	virConnectPtr	con;
	int	usageType = (int)SvIV(ST(1));
	const char *	usageID = (const char *)SvPV_nolen(ST(2));
	virSecretPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Secret::_lookup_by_usage() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4878 "Virt.xs"
      if (!(RETVAL = virSecretLookupByUsage(con, usageType, usageID))) {
	_croak_error();
      }
#line 10963 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Secret", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Secret__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virSecretPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Secret::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4890 "Virt.xs"
      if (!(RETVAL = virSecretLookupByUUID(con, uuid)))
          _croak_error();
#line 10998 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Secret", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Secret__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virSecretPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Secret::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4901 "Virt.xs"
      if (!(RETVAL = virSecretLookupByUUIDString(con, uuid)))
          _croak_error();
#line 11033 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Secret", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Secret_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	virSecretPtr	sec;
#line 4911 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 11058 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = (virSecretPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Secret::get_uuid() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4913 "Virt.xs"
      if ((virSecretGetUUID(sec, rawuuid)) < 0)
          _croak_error();

      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 11072 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Secret_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	virSecretPtr	sec;
#line 4925 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 11094 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = (virSecretPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Secret::get_uuid_string() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4927 "Virt.xs"
      if ((virSecretGetUUIDString(sec, uuid)) < 0)
          _croak_error();

      RETVAL = newSVpv(uuid, 0);
#line 11108 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Secret_get_usage_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret_get_usage_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	virSecretPtr	sec;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = (virSecretPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Secret::get_usage_id() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4939 "Virt.xs"
      if (!(RETVAL = virSecretGetUsageID(sec)))
          _croak_error();
#line 11140 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Secret_get_usage_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret_get_usage_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	virSecretPtr	sec;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = (virSecretPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Secret::get_usage_type() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4949 "Virt.xs"
      if (!(RETVAL = virSecretGetUsageType(sec)))
          _croak_error();
#line 11171 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Secret_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "sec, flags=0");
    {
	virSecretPtr	sec;
	unsigned int	flags;
#line 4960 "Virt.xs"
      char *xml;
#line 11193 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = (virSecretPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Secret::get_xml_description() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 4962 "Virt.xs"
      if (!(xml = virSecretGetXMLDesc(sec, flags)))
          _croak_error();
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 11213 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Secret_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virSecretPtr	sec;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = (virSecretPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Secret::undefine() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 4974 "Virt.xs"
      if (virSecretUndefine(sec) < 0)
          _croak_error();
#line 11245 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Secret_set_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret_set_value)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sec, value, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virSecretPtr	sec;
	SV *	value = ST(1);
	unsigned int	flags;
#line 4984 "Virt.xs"
      unsigned char *bytes;
      STRLEN len;
#line 11271 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = (virSecretPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Secret::set_value() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 4987 "Virt.xs"
      bytes = (unsigned char *)SvPV(value, len);
      if (virSecretSetValue(sec, bytes, len, flags) < 0)
          _croak_error();
#line 11289 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Secret_get_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret_get_value)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "sec, flags=0");
    {
	virSecretPtr	sec;
	unsigned int	flags;
#line 4997 "Virt.xs"
      unsigned char *bytes;
      size_t len;
#line 11312 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = (virSecretPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Secret::get_value() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 5000 "Virt.xs"
      if ((bytes = virSecretGetValue(sec, &len, flags)) == NULL)
          _croak_error();

      RETVAL = newSVpv((char*)bytes, len);
#line 11332 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Secret_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Secret_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sec_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sec_rv = ST(0);
#line 5013 "Virt.xs"
      virSecretPtr sec;
#line 11356 "Virt.c"
#line 5015 "Virt.xs"
      sec = (virSecretPtr)SvIV((SV*)SvRV(sec_rv));
      if (sec) {
          virSecretFree(sec);
          sv_setiv((SV*)SvRV(sec_rv), 0);
      }
#line 11363 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NWFilter__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NWFilter__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virNWFilterPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NWFilter::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5030 "Virt.xs"
      if (!(RETVAL = virNWFilterDefineXML(con, xml)))
          _croak_error();
#line 11394 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NWFilter", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NWFilter__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NWFilter__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virNWFilterPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NWFilter::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5041 "Virt.xs"
      if (!(RETVAL = virNWFilterLookupByName(con, name)))
          _croak_error();
#line 11428 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NWFilter", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NWFilter__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NWFilter__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virNWFilterPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NWFilter::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5052 "Virt.xs"
      if (!(RETVAL = virNWFilterLookupByUUID(con, uuid)))
          _croak_error();
#line 11462 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NWFilter", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NWFilter__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NWFilter__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virNWFilterPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NWFilter::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5063 "Virt.xs"
      if (!(RETVAL = virNWFilterLookupByUUIDString(con, uuid)))
          _croak_error();
#line 11496 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NWFilter", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NWFilter_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NWFilter_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "filter");
    {
	virNWFilterPtr	filter;
#line 5073 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 11520 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = (virNWFilterPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NWFilter::get_uuid() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5075 "Virt.xs"
      if ((virNWFilterGetUUID(filter, rawuuid)) < 0)
          _croak_error();

      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 11534 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NWFilter_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NWFilter_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "filter");
    {
	virNWFilterPtr	filter;
#line 5087 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 11556 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = (virNWFilterPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NWFilter::get_uuid_string() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5089 "Virt.xs"
      if ((virNWFilterGetUUIDString(filter, uuid)) < 0)
          _croak_error();

      RETVAL = newSVpv(uuid, 0);
#line 11570 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NWFilter_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NWFilter_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "filter");
    {
	virNWFilterPtr	filter;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = (virNWFilterPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NWFilter::get_name() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5101 "Virt.xs"
      if (!(RETVAL = virNWFilterGetName(filter)))
          _croak_error();
#line 11602 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NWFilter_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NWFilter_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "filter, flags=0");
    {
	virNWFilterPtr	filter;
	unsigned int	flags;
#line 5112 "Virt.xs"
      char *xml;
#line 11624 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = (virNWFilterPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NWFilter::get_xml_description() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 5114 "Virt.xs"
      if (!(xml = virNWFilterGetXMLDesc(filter, flags)))
          _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 11645 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NWFilter_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NWFilter_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "filter");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNWFilterPtr	filter;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = (virNWFilterPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NWFilter::undefine() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5127 "Virt.xs"
      if (virNWFilterUndefine(filter) < 0)
          _croak_error();
#line 11677 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NWFilter_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NWFilter_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "filter_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	filter_rv = ST(0);
#line 5134 "Virt.xs"
      virNWFilterPtr filter;
#line 11700 "Virt.c"
#line 5136 "Virt.xs"
      filter = (virNWFilterPtr)SvIV((SV*)SvRV(filter_rv));
      if (filter) {
          virNWFilterFree(filter);
          sv_setiv((SV*)SvRV(filter_rv), 0);
      }
#line 11707 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__DomainSnapshot__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__DomainSnapshot__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
	virDomainSnapshotPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::DomainSnapshot::_create_xml() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 5152 "Virt.xs"
      if (!(RETVAL = virDomainSnapshotCreateXML(dom, xml, flags)))
          _croak_error();
#line 11745 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::DomainSnapshot", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__DomainSnapshot__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__DomainSnapshot__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, name, flags=0");
    {
	virDomainPtr	dom;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
	virDomainSnapshotPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::DomainSnapshot::_lookup_by_name() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 5164 "Virt.xs"
      if (!(RETVAL = virDomainSnapshotLookupByName(dom, name, flags)))
          _croak_error();
#line 11786 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::DomainSnapshot", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__DomainSnapshot_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__DomainSnapshot_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "domss");
    {
	virDomainSnapshotPtr	domss;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = (virDomainSnapshotPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::DomainSnapshot::get_name() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5174 "Virt.xs"
      if (!(RETVAL = virDomainSnapshotGetName(domss)))
          _croak_error();
#line 11820 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__DomainSnapshot_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__DomainSnapshot_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
#line 5185 "Virt.xs"
      char *xml;
#line 11842 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = (virDomainSnapshotPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::DomainSnapshot::get_xml_description() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 5187 "Virt.xs"
      if (!(xml = virDomainSnapshotGetXMLDesc(domss, flags)))
          _croak_error();
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 11862 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__DomainSnapshot_revert_to); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__DomainSnapshot_revert_to)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = (virDomainSnapshotPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::DomainSnapshot::revert_to() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 5200 "Virt.xs"
      if (virDomainRevertToSnapshot(domss, flags) < 0)
          _croak_error();
#line 11901 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__DomainSnapshot_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__DomainSnapshot_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = (virDomainSnapshotPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::DomainSnapshot::delete() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 5209 "Virt.xs"
      if (virDomainSnapshotDelete(domss, flags) < 0)
          _croak_error();
#line 11939 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__DomainSnapshot_get_parent); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__DomainSnapshot_get_parent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
	virDomainSnapshotPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = (virDomainSnapshotPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::DomainSnapshot::get_parent() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 5218 "Virt.xs"
      if (!(RETVAL = virDomainSnapshotGetParent(domss, flags)))
          _croak_error();
#line 11976 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::DomainSnapshot", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__DomainSnapshot_num_of_child_snapshots); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__DomainSnapshot_num_of_child_snapshots)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = (virDomainSnapshotPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::DomainSnapshot::num_of_child_snapshots() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 5229 "Virt.xs"
      if ((RETVAL = virDomainSnapshotNumChildren(domss, flags)) < 0)
          _croak_error();
#line 12017 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__DomainSnapshot_list_child_snapshot_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__DomainSnapshot_list_child_snapshot_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "domss, maxnames, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainSnapshotPtr	domss;
	int	maxnames = (int)SvIV(ST(1));
	unsigned int	flags;
#line 5241 "Virt.xs"
      char **names;
      int nsnap;
      int i;
#line 12044 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = (virDomainSnapshotPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::DomainSnapshot::list_child_snapshot_names() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 5245 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nsnap = virDomainSnapshotListChildrenNames(domss, names, maxnames, flags)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nsnap);
      for (i = 0 ; i < nsnap ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 12070 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__DomainSnapshot_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__DomainSnapshot_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "domss_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	domss_rv = ST(0);
#line 5262 "Virt.xs"
      virDomainSnapshotPtr domss;
#line 12093 "Virt.c"
#line 5264 "Virt.xs"
      domss = (virDomainSnapshotPtr)SvIV((SV*)SvRV(domss_rv));
      if (domss) {
          virDomainSnapshotFree(domss);
          sv_setiv((SV*)SvRV(domss_rv), 0);
      }
#line 12100 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event__register_impl); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event__register_impl)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 5280 "Virt.xs"
      virEventRegisterImpl(_event_add_handle,
			   _event_update_handle,
			   _event_remove_handle,
			   _event_add_timeout,
			   _event_update_timeout,
			   _event_remove_timeout);
#line 12127 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event_register_default); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event_register_default)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 5291 "Virt.xs"
      virEventRegisterDefaultImpl();
#line 12149 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event_run_default); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event_run_default)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 5297 "Virt.xs"
      virEventRunDefaultImpl();
#line 12171 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event_add_handle); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event_add_handle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "fd, events, coderef");
    {
	int	fd = (int)SvIV(ST(0));
	int	events = (int)SvIV(ST(1));
	SV *	coderef = ST(2);
#line 5306 "Virt.xs"
      int watch;
#line 12194 "Virt.c"
	int	RETVAL;
	dXSTARG;
#line 5308 "Virt.xs"
      SvREFCNT_inc(coderef);

      if ((watch = virEventAddHandle(fd, events, _event_handle_helper, coderef, _event_cb_free)) < 0) {
          SvREFCNT_dec(coderef);
          _croak_error();
      }
      RETVAL = watch;
#line 12205 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Event_update_handle); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event_update_handle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "watch, events");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	watch = (int)SvIV(ST(0));
	int	events = (int)SvIV(ST(1));
#line 5324 "Virt.xs"
      virEventUpdateHandle(watch, events);
#line 12229 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event_remove_handle); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event_remove_handle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "watch");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	watch = (int)SvIV(ST(0));
#line 5331 "Virt.xs"
      if (virEventRemoveHandle(watch) < 0)
          _croak_error();
#line 12253 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event_add_timeout); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event_add_timeout)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "frequency, coderef");
    {
	int	frequency = (int)SvIV(ST(0));
	SV *	coderef = ST(1);
#line 5340 "Virt.xs"
      int timer;
#line 12275 "Virt.c"
	int	RETVAL;
	dXSTARG;
#line 5342 "Virt.xs"
      SvREFCNT_inc(coderef);

      if ((timer = virEventAddTimeout(frequency, _event_timeout_helper, coderef, _event_cb_free)) < 0) {
          SvREFCNT_dec(coderef);
          _croak_error();
      }
      RETVAL = timer;
#line 12286 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Event_update_timeout); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event_update_timeout)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "timer, frequency");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	timer = (int)SvIV(ST(0));
	int	frequency = (int)SvIV(ST(1));
#line 5358 "Virt.xs"
      virEventUpdateTimeout(timer, frequency);
#line 12310 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event_remove_timeout); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event_remove_timeout)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "timer");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	timer = (int)SvIV(ST(0));
#line 5365 "Virt.xs"
      if (virEventRemoveTimeout(timer) < 0)
          _croak_error();
#line 12334 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event__run_handle_callback_helper); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event__run_handle_callback_helper)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "watch, fd, event, cbref, opaqueref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	watch = (int)SvIV(ST(0));
	int	fd = (int)SvIV(ST(1));
	int	event = (int)SvIV(ST(2));
	SV *	cbref = ST(3);
	SV *	opaqueref = ST(4);
#line 5377 "Virt.xs"
      virEventHandleCallback cb;
      void *opaque;
#line 12362 "Virt.c"
#line 5380 "Virt.xs"
      cb = (virEventHandleCallback)SvIV((SV*)SvRV(cbref));
      opaque = (void*)SvIV((SV*)SvRV(opaqueref));

      cb(watch, fd, event, opaque);
#line 12368 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event__run_timeout_callback_helper); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event__run_timeout_callback_helper)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "timer, cbref, opaqueref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	timer = (int)SvIV(ST(0));
	SV *	cbref = ST(1);
	SV *	opaqueref = ST(2);
#line 5392 "Virt.xs"
      virEventTimeoutCallback cb;
      void *opaque;
#line 12394 "Virt.c"
#line 5395 "Virt.xs"
      cb = (virEventTimeoutCallback)SvIV((SV*)SvRV(cbref));
      opaque = (void*)SvIV((SV*)SvRV(opaqueref));

      cb(timer, opaque);
#line 12400 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event__free_callback_opaque_helper); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event__free_callback_opaque_helper)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ffref, opaqueref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ffref = ST(0);
	SV *	opaqueref = ST(1);
#line 5406 "Virt.xs"
      virFreeCallback ff;
      void *opaque;
#line 12425 "Virt.c"
#line 5409 "Virt.xs"
      opaque = SvOK(opaqueref) ? (void*)SvIV((SV*)SvRV(opaqueref)) : NULL;
      ff = SvOK(ffref) ? (virFreeCallback)SvIV((SV*)SvRV(ffref)) : NULL;

      if (opaque != NULL && ff != NULL)
        ff(opaque);
#line 12432 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Stream__new_obj); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Stream__new_obj)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    {
	virConnectPtr	con;
	unsigned int	flags;
	virStreamPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Stream::_new_obj() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 5424 "Virt.xs"
      if (!(RETVAL = virStreamNew(con, flags)))
          _croak_error();
#line 12469 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Stream", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Stream_send); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Stream_send)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "st, data, nbytes");
    {
	virStreamPtr	st;
	SV *	data = ST(1);
	size_t	nbytes = (size_t)SvUV(ST(2));
#line 5436 "Virt.xs"
      const char *rawdata;
      STRLEN len;
#line 12494 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = (virStreamPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Stream::send() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5439 "Virt.xs"
      if (SvOK(data)) {
	  rawdata = SvPV(data, len);
          if (nbytes < 0 || nbytes > len)
              nbytes = len;
      } else {
          rawdata = "";
          nbytes = 0;
      }

      if ((RETVAL = virStreamSend(st, rawdata, nbytes)) < 0 &&
          RETVAL != -2)
          _croak_error();
#line 12517 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Stream_recv); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Stream_recv)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "st, data, nbytes");
    {
	virStreamPtr	st;
	SV *	data = ST(1);
	size_t	nbytes = (size_t)SvUV(ST(2));
#line 5461 "Virt.xs"
      char *rawdata;
#line 12540 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = (virStreamPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Stream::recv() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5463 "Virt.xs"
      Newx(rawdata, nbytes, char);
      if ((RETVAL = virStreamRecv(st, rawdata, nbytes)) < 0 &&
          RETVAL != -2) {
          Safefree(rawdata);
          _croak_error();
      }
      if (RETVAL > 0) {
          sv_setpvn(data, rawdata, RETVAL);
      }
      Safefree(rawdata);
#line 12561 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Stream_send_all); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Stream_send_all)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "stref, handler");
    {
	SV *	stref = ST(0);
	SV *	handler = ST(1);
#line 5482 "Virt.xs"
      AV *opaque;
      virStreamPtr st;
#line 12584 "Virt.c"
#line 5485 "Virt.xs"
      st = (virStreamPtr)SvIV((SV*)SvRV(stref));

      opaque = newAV();
      SvREFCNT_inc(handler);
      SvREFCNT_inc(stref);
      av_push(opaque, stref);
      av_push(opaque, handler);

      if (virStreamSendAll(st, _stream_send_all_source, opaque) < 0)
          _croak_error();

      SvREFCNT_dec(opaque);
#line 12598 "Virt.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Sys__Virt__Stream_recv_all); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Stream_recv_all)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "stref, handler");
    {
	SV *	stref = ST(0);
	SV *	handler = ST(1);
#line 5504 "Virt.xs"
      AV *opaque;
      virStreamPtr st;
#line 12620 "Virt.c"
#line 5507 "Virt.xs"
      st = (virStreamPtr)SvIV((SV*)SvRV(stref));

      opaque = newAV();
      SvREFCNT_inc(handler);
      SvREFCNT_inc(stref);
      av_push(opaque, stref);
      av_push(opaque, handler);

      if (virStreamRecvAll(st, _stream_recv_all_sink, opaque) < 0)
          _croak_error();

      SvREFCNT_dec(opaque);
#line 12634 "Virt.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Sys__Virt__Stream_add_callback); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Stream_add_callback)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "stref, events, cb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	stref = ST(0);
	int	events = (int)SvIV(ST(1));
	SV*	cb = ST(2);
#line 5527 "Virt.xs"
      AV *opaque;
      virStreamPtr st;
#line 12659 "Virt.c"
#line 5530 "Virt.xs"
      st = (virStreamPtr)SvIV((SV*)SvRV(stref));

      opaque = newAV();
      SvREFCNT_inc(cb);
      SvREFCNT_inc(stref);
      av_push(opaque, stref);
      av_push(opaque, cb);
      if (virStreamEventAddCallback(st, events, _stream_event_callback, opaque, _stream_event_free) < 0)
          _croak_error();
#line 12670 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Stream_update_callback); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Stream_update_callback)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "st, events");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;
	int	events = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = (virStreamPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Stream::update_callback() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5546 "Virt.xs"
      if (virStreamEventUpdateCallback(st, events) < 0)
          _croak_error();
#line 12702 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Stream_remove_callback); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Stream_remove_callback)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "st");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = (virStreamPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Stream::remove_callback() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5554 "Virt.xs"
      if (virStreamEventRemoveCallback(st) < 0)
          _croak_error();
#line 12733 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Stream_finish); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Stream_finish)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "st");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = (virStreamPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Stream::finish() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5562 "Virt.xs"
      if (virStreamFinish(st) < 0)
          _croak_error();
#line 12764 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Stream_abort); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Stream_abort)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "st");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = (virStreamPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Stream::abort() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 5570 "Virt.xs"
      if (virStreamAbort(st) < 0)
          _croak_error();
#line 12795 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Stream_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Stream_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "st_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	st_rv = ST(0);
#line 5578 "Virt.xs"
      virStreamPtr st;
#line 12818 "Virt.c"
#line 5580 "Virt.xs"
      st = (virStreamPtr)SvIV((SV*)SvRV(st_rv));
      if (st) {
	virStreamFree(st);
	sv_setiv((SV*)SvRV(st_rv), 0);
      }
#line 12825 "Virt.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Sys__Virt); /* prototype to pass -Wmissing-prototypes */
XS(boot_Sys__Virt)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        (void)newXSproto_portable("Sys::Virt::_open", XS_Sys__Virt__open, file, "$$");
        (void)newXSproto_portable("Sys::Virt::_open_auth", XS_Sys__Virt__open_auth, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::restore_domain", XS_Sys__Virt_restore_domain, file, "$$;$$");
        (void)newXSproto_portable("Sys::Virt::get_save_image_xml_description", XS_Sys__Virt_get_save_image_xml_description, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::define_save_image_xml", XS_Sys__Virt_define_save_image_xml, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::_get_library_version", XS_Sys__Virt__get_library_version, file, "$");
        (void)newXSproto_portable("Sys::Virt::_get_conn_version", XS_Sys__Virt__get_conn_version, file, "$");
        (void)newXSproto_portable("Sys::Virt::_get_conn_library_version", XS_Sys__Virt__get_conn_library_version, file, "$");
        (void)newXSproto_portable("Sys::Virt::is_encrypted", XS_Sys__Virt_is_encrypted, file, "$");
        (void)newXSproto_portable("Sys::Virt::is_secure", XS_Sys__Virt_is_secure, file, "$");
        (void)newXSproto_portable("Sys::Virt::is_alive", XS_Sys__Virt_is_alive, file, "$");
        (void)newXSproto_portable("Sys::Virt::set_keep_alive", XS_Sys__Virt_set_keep_alive, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::get_type", XS_Sys__Virt_get_type, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_uri", XS_Sys__Virt_get_uri, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_sysinfo", XS_Sys__Virt_get_sysinfo, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::get_node_info", XS_Sys__Virt_get_node_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_node_security_model", XS_Sys__Virt_get_node_security_model, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_node_free_memory", XS_Sys__Virt_get_node_free_memory, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_node_cells_free_memory", XS_Sys__Virt_get_node_cells_free_memory, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::get_node_cpu_stats", XS_Sys__Virt_get_node_cpu_stats, file, "$;$$");
        (void)newXSproto_portable("Sys::Virt::get_node_memory_stats", XS_Sys__Virt_get_node_memory_stats, file, "$;$$");
        (void)newXSproto_portable("Sys::Virt::node_suspend_for_duration", XS_Sys__Virt_node_suspend_for_duration, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::find_storage_pool_sources", XS_Sys__Virt_find_storage_pool_sources, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::get_capabilities", XS_Sys__Virt_get_capabilities, file, "$");
        (void)newXSproto_portable("Sys::Virt::compare_cpu", XS_Sys__Virt_compare_cpu, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::baseline_cpu", XS_Sys__Virt_baseline_cpu, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::get_max_vcpus", XS_Sys__Virt_get_max_vcpus, file, "$$");
        (void)newXSproto_portable("Sys::Virt::get_hostname", XS_Sys__Virt_get_hostname, file, "$");
        (void)newXSproto_portable("Sys::Virt::num_of_domains", XS_Sys__Virt_num_of_domains, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_domain_ids", XS_Sys__Virt_list_domain_ids, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_defined_domains", XS_Sys__Virt_num_of_defined_domains, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_defined_domain_names", XS_Sys__Virt_list_defined_domain_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_networks", XS_Sys__Virt_num_of_networks, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_network_names", XS_Sys__Virt_list_network_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_defined_networks", XS_Sys__Virt_num_of_defined_networks, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_defined_network_names", XS_Sys__Virt_list_defined_network_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_storage_pools", XS_Sys__Virt_num_of_storage_pools, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_storage_pool_names", XS_Sys__Virt_list_storage_pool_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_defined_storage_pools", XS_Sys__Virt_num_of_defined_storage_pools, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_defined_storage_pool_names", XS_Sys__Virt_list_defined_storage_pool_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_node_devices", XS_Sys__Virt_num_of_node_devices, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::list_node_device_names", XS_Sys__Virt_list_node_device_names, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::num_of_interfaces", XS_Sys__Virt_num_of_interfaces, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_interface_names", XS_Sys__Virt_list_interface_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_defined_interfaces", XS_Sys__Virt_num_of_defined_interfaces, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_defined_interface_names", XS_Sys__Virt_list_defined_interface_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_secrets", XS_Sys__Virt_num_of_secrets, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_secret_uuids", XS_Sys__Virt_list_secret_uuids, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_nwfilters", XS_Sys__Virt_num_of_nwfilters, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_nwfilter_names", XS_Sys__Virt_list_nwfilter_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::domain_xml_from_native", XS_Sys__Virt_domain_xml_from_native, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::domain_xml_to_native", XS_Sys__Virt_domain_xml_to_native, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::domain_event_register", XS_Sys__Virt_domain_event_register, file, "$$");
        (void)newXSproto_portable("Sys::Virt::domain_event_deregister", XS_Sys__Virt_domain_event_deregister, file, "$");
        (void)newXSproto_portable("Sys::Virt::domain_event_register_any", XS_Sys__Virt_domain_event_register_any, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::domain_event_deregister_any", XS_Sys__Virt_domain_event_deregister_any, file, "$$");
        (void)newXSproto_portable("Sys::Virt::interface_change_begin", XS_Sys__Virt_interface_change_begin, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::interface_change_commit", XS_Sys__Virt_interface_change_commit, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::interface_change_rollback", XS_Sys__Virt_interface_change_rollback, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DESTROY", XS_Sys__Virt_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::_create", XS_Sys__Virt__Domain__create, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::_define_xml", XS_Sys__Virt__Domain__define_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::_lookup_by_id", XS_Sys__Virt__Domain__lookup_by_id, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::_lookup_by_name", XS_Sys__Virt__Domain__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::_lookup_by_uuid", XS_Sys__Virt__Domain__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::_lookup_by_uuid_string", XS_Sys__Virt__Domain__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_id", XS_Sys__Virt__Domain_get_id, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_uuid", XS_Sys__Virt__Domain_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_uuid_string", XS_Sys__Virt__Domain_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_name", XS_Sys__Virt__Domain_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_metadata", XS_Sys__Virt__Domain_get_metadata, file, "$$;$$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_metadata", XS_Sys__Virt__Domain_set_metadata, file, "$$;$$$$");
        (void)newXSproto_portable("Sys::Virt::Domain::is_active", XS_Sys__Virt__Domain_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::is_persistent", XS_Sys__Virt__Domain_is_persistent, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::is_updated", XS_Sys__Virt__Domain_is_updated, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::suspend", XS_Sys__Virt__Domain_suspend, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::resume", XS_Sys__Virt__Domain_resume, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::pm_wakeup", XS_Sys__Virt__Domain_pm_wakeup, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::save", XS_Sys__Virt__Domain_save, file, "$$;$$");
        (void)newXSproto_portable("Sys::Virt::Domain::managed_save", XS_Sys__Virt__Domain_managed_save, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::has_managed_save_image", XS_Sys__Virt__Domain_has_managed_save_image, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::managed_save_remove", XS_Sys__Virt__Domain_managed_save_remove, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::core_dump", XS_Sys__Virt__Domain_core_dump, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_info", XS_Sys__Virt__Domain_get_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_control_info", XS_Sys__Virt__Domain_get_control_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_state", XS_Sys__Virt__Domain_get_state, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::open_console", XS_Sys__Virt__Domain_open_console, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::open_graphics", XS_Sys__Virt__Domain_open_graphics, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::screenshot", XS_Sys__Virt__Domain_screenshot, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_block_info", XS_Sys__Virt__Domain_get_block_info, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_job_info", XS_Sys__Virt__Domain_get_job_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::abort_job", XS_Sys__Virt__Domain_abort_job, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::abort_block_job", XS_Sys__Virt__Domain_abort_block_job, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_block_job_info", XS_Sys__Virt__Domain_get_block_job_info, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_block_job_speed", XS_Sys__Virt__Domain_set_block_job_speed, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_pull", XS_Sys__Virt__Domain_block_pull, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_rebase", XS_Sys__Virt__Domain_block_rebase, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_disk_errors", XS_Sys__Virt__Domain_get_disk_errors, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_scheduler_parameters", XS_Sys__Virt__Domain_get_scheduler_parameters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_scheduler_parameters", XS_Sys__Virt__Domain_set_scheduler_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_memory_parameters", XS_Sys__Virt__Domain_get_memory_parameters, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_memory_parameters", XS_Sys__Virt__Domain_set_memory_parameters, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_numa_parameters", XS_Sys__Virt__Domain_get_numa_parameters, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_numa_parameters", XS_Sys__Virt__Domain_set_numa_parameters, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_blkio_parameters", XS_Sys__Virt__Domain_get_blkio_parameters, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_blkio_parameters", XS_Sys__Virt__Domain_set_blkio_parameters, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_max_memory", XS_Sys__Virt__Domain_get_max_memory, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_max_memory", XS_Sys__Virt__Domain_set_max_memory, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_memory", XS_Sys__Virt__Domain_set_memory, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_max_vcpus", XS_Sys__Virt__Domain_get_max_vcpus, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_vcpus", XS_Sys__Virt__Domain_set_vcpus, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_vcpus", XS_Sys__Virt__Domain_get_vcpus, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_autostart", XS_Sys__Virt__Domain_set_autostart, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_autostart", XS_Sys__Virt__Domain_get_autostart, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_scheduler_type", XS_Sys__Virt__Domain_get_scheduler_type, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_os_type", XS_Sys__Virt__Domain_get_os_type, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_xml_description", XS_Sys__Virt__Domain_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::shutdown", XS_Sys__Virt__Domain_shutdown, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::reboot", XS_Sys__Virt__Domain_reboot, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::pm_suspend_for_duration", XS_Sys__Virt__Domain_pm_suspend_for_duration, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::Domain::reset", XS_Sys__Virt__Domain_reset, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::inject_nmi", XS_Sys__Virt__Domain_inject_nmi, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::undefine", XS_Sys__Virt__Domain_undefine, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::create", XS_Sys__Virt__Domain_create, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate", XS_Sys__Virt__Domain_migrate, file, "$$;$$$$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_to_uri", XS_Sys__Virt__Domain_migrate_to_uri, file, "$$;$$$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate2", XS_Sys__Virt__Domain_migrate2, file, "$$;$$$$$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_to_uri2", XS_Sys__Virt__Domain_migrate_to_uri2, file, "$$;$$$$$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_set_max_downtime", XS_Sys__Virt__Domain_migrate_set_max_downtime, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_set_max_speed", XS_Sys__Virt__Domain_migrate_set_max_speed, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_get_max_speed", XS_Sys__Virt__Domain_migrate_get_max_speed, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::attach_device", XS_Sys__Virt__Domain_attach_device, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::detach_device", XS_Sys__Virt__Domain_detach_device, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::update_device", XS_Sys__Virt__Domain_update_device, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_block_iotune", XS_Sys__Virt__Domain_get_block_iotune, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_block_iotune", XS_Sys__Virt__Domain_set_block_iotune, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_interface_parameters", XS_Sys__Virt__Domain_get_interface_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_interface_parameters", XS_Sys__Virt__Domain_set_interface_parameters, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_stats", XS_Sys__Virt__Domain_block_stats, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::interface_stats", XS_Sys__Virt__Domain_interface_stats, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::memory_stats", XS_Sys__Virt__Domain_memory_stats, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::send_key", XS_Sys__Virt__Domain_send_key, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_resize", XS_Sys__Virt__Domain_block_resize, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_peek", XS_Sys__Virt__Domain_block_peek, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::memory_peek", XS_Sys__Virt__Domain_memory_peek, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_security_label", XS_Sys__Virt__Domain_get_security_label, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_cpu_stats", XS_Sys__Virt__Domain_get_cpu_stats, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_vcpu_info", XS_Sys__Virt__Domain_get_vcpu_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::pin_vcpu", XS_Sys__Virt__Domain_pin_vcpu, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::num_of_snapshots", XS_Sys__Virt__Domain_num_of_snapshots, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::list_snapshot_names", XS_Sys__Virt__Domain_list_snapshot_names, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::has_current_snapshot", XS_Sys__Virt__Domain_has_current_snapshot, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::current_snapshot", XS_Sys__Virt__Domain_current_snapshot, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::destroy", XS_Sys__Virt__Domain_destroy, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::DESTROY", XS_Sys__Virt__Domain_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::_create_xml", XS_Sys__Virt__Network__create_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::_define_xml", XS_Sys__Virt__Network__define_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::_lookup_by_name", XS_Sys__Virt__Network__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::_lookup_by_uuid", XS_Sys__Virt__Network__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::_lookup_by_uuid_string", XS_Sys__Virt__Network__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::get_uuid", XS_Sys__Virt__Network_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_uuid_string", XS_Sys__Virt__Network_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_name", XS_Sys__Virt__Network_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::is_active", XS_Sys__Virt__Network_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::is_persistent", XS_Sys__Virt__Network_is_persistent, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_bridge_name", XS_Sys__Virt__Network_get_bridge_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_xml_description", XS_Sys__Virt__Network_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Network::undefine", XS_Sys__Virt__Network_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::create", XS_Sys__Virt__Network_create, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::set_autostart", XS_Sys__Virt__Network_set_autostart, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::get_autostart", XS_Sys__Virt__Network_get_autostart, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::destroy", XS_Sys__Virt__Network_destroy, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::DESTROY", XS_Sys__Virt__Network_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_create_xml", XS_Sys__Virt__StoragePool__create_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_define_xml", XS_Sys__Virt__StoragePool__define_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_name", XS_Sys__Virt__StoragePool__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_uuid", XS_Sys__Virt__StoragePool__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_uuid_string", XS_Sys__Virt__StoragePool__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_volume", XS_Sys__Virt__StoragePool__lookup_by_volume, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_uuid", XS_Sys__Virt__StoragePool_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_uuid_string", XS_Sys__Virt__StoragePool_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_name", XS_Sys__Virt__StoragePool_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::is_active", XS_Sys__Virt__StoragePool_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::is_persistent", XS_Sys__Virt__StoragePool_is_persistent, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_xml_description", XS_Sys__Virt__StoragePool_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::undefine", XS_Sys__Virt__StoragePool_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::create", XS_Sys__Virt__StoragePool_create, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::refresh", XS_Sys__Virt__StoragePool_refresh, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::build", XS_Sys__Virt__StoragePool_build, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::delete", XS_Sys__Virt__StoragePool_delete, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::set_autostart", XS_Sys__Virt__StoragePool_set_autostart, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_autostart", XS_Sys__Virt__StoragePool_get_autostart, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_info", XS_Sys__Virt__StoragePool_get_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::destroy", XS_Sys__Virt__StoragePool_destroy, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::num_of_storage_volumes", XS_Sys__Virt__StoragePool_num_of_storage_volumes, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::list_storage_vol_names", XS_Sys__Virt__StoragePool_list_storage_vol_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::DESTROY", XS_Sys__Virt__StoragePool_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_create_xml", XS_Sys__Virt__StorageVol__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_create_xml_from", XS_Sys__Virt__StorageVol__create_xml_from, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_lookup_by_name", XS_Sys__Virt__StorageVol__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_lookup_by_key", XS_Sys__Virt__StorageVol__lookup_by_key, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_lookup_by_path", XS_Sys__Virt__StorageVol__lookup_by_path, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_name", XS_Sys__Virt__StorageVol_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_key", XS_Sys__Virt__StorageVol_get_key, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_path", XS_Sys__Virt__StorageVol_get_path, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::resize", XS_Sys__Virt__StorageVol_resize, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_xml_description", XS_Sys__Virt__StorageVol_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::delete", XS_Sys__Virt__StorageVol_delete, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::wipe", XS_Sys__Virt__StorageVol_wipe, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::wipe_pattern", XS_Sys__Virt__StorageVol_wipe_pattern, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_info", XS_Sys__Virt__StorageVol_get_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::download", XS_Sys__Virt__StorageVol_download, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::upload", XS_Sys__Virt__StorageVol_upload, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::DESTROY", XS_Sys__Virt__StorageVol_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::_create_xml", XS_Sys__Virt__NodeDevice__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::_lookup_by_name", XS_Sys__Virt__NodeDevice__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::get_name", XS_Sys__Virt__NodeDevice_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::get_parent", XS_Sys__Virt__NodeDevice_get_parent, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::get_xml_description", XS_Sys__Virt__NodeDevice_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::dettach", XS_Sys__Virt__NodeDevice_dettach, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::reattach", XS_Sys__Virt__NodeDevice_reattach, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::reset", XS_Sys__Virt__NodeDevice_reset, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::list_capabilities", XS_Sys__Virt__NodeDevice_list_capabilities, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::destroy", XS_Sys__Virt__NodeDevice_destroy, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::DESTROY", XS_Sys__Virt__NodeDevice_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::_define_xml", XS_Sys__Virt__Interface__define_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Interface::_lookup_by_name", XS_Sys__Virt__Interface__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Interface::_lookup_by_mac", XS_Sys__Virt__Interface__lookup_by_mac, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Interface::get_mac", XS_Sys__Virt__Interface_get_mac, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::get_name", XS_Sys__Virt__Interface_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::is_active", XS_Sys__Virt__Interface_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::get_xml_description", XS_Sys__Virt__Interface_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Interface::undefine", XS_Sys__Virt__Interface_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::create", XS_Sys__Virt__Interface_create, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Interface::destroy", XS_Sys__Virt__Interface_destroy, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Interface::DESTROY", XS_Sys__Virt__Interface_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::_define_xml", XS_Sys__Virt__Secret__define_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Secret::_lookup_by_usage", XS_Sys__Virt__Secret__lookup_by_usage, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Secret::_lookup_by_uuid", XS_Sys__Virt__Secret__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Secret::_lookup_by_uuid_string", XS_Sys__Virt__Secret__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_uuid", XS_Sys__Virt__Secret_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_uuid_string", XS_Sys__Virt__Secret_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_usage_id", XS_Sys__Virt__Secret_get_usage_id, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_usage_type", XS_Sys__Virt__Secret_get_usage_type, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_xml_description", XS_Sys__Virt__Secret_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Secret::undefine", XS_Sys__Virt__Secret_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::set_value", XS_Sys__Virt__Secret_set_value, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_value", XS_Sys__Virt__Secret_get_value, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Secret::DESTROY", XS_Sys__Virt__Secret_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::_define_xml", XS_Sys__Virt__NWFilter__define_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::_lookup_by_name", XS_Sys__Virt__NWFilter__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::_lookup_by_uuid", XS_Sys__Virt__NWFilter__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::_lookup_by_uuid_string", XS_Sys__Virt__NWFilter__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::get_uuid", XS_Sys__Virt__NWFilter_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::get_uuid_string", XS_Sys__Virt__NWFilter_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::get_name", XS_Sys__Virt__NWFilter_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::get_xml_description", XS_Sys__Virt__NWFilter_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::undefine", XS_Sys__Virt__NWFilter_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::DESTROY", XS_Sys__Virt__NWFilter_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::_create_xml", XS_Sys__Virt__DomainSnapshot__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::_lookup_by_name", XS_Sys__Virt__DomainSnapshot__lookup_by_name, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::get_name", XS_Sys__Virt__DomainSnapshot_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::get_xml_description", XS_Sys__Virt__DomainSnapshot_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::revert_to", XS_Sys__Virt__DomainSnapshot_revert_to, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::delete", XS_Sys__Virt__DomainSnapshot_delete, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::get_parent", XS_Sys__Virt__DomainSnapshot_get_parent, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::num_of_child_snapshots", XS_Sys__Virt__DomainSnapshot_num_of_child_snapshots, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::list_child_snapshot_names", XS_Sys__Virt__DomainSnapshot_list_child_snapshot_names, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::DESTROY", XS_Sys__Virt__DomainSnapshot_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Event::_register_impl", XS_Sys__Virt__Event__register_impl, file, "");
        (void)newXSproto_portable("Sys::Virt::Event::register_default", XS_Sys__Virt__Event_register_default, file, "");
        (void)newXSproto_portable("Sys::Virt::Event::run_default", XS_Sys__Virt__Event_run_default, file, "");
        (void)newXSproto_portable("Sys::Virt::Event::add_handle", XS_Sys__Virt__Event_add_handle, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Event::update_handle", XS_Sys__Virt__Event_update_handle, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Event::remove_handle", XS_Sys__Virt__Event_remove_handle, file, "$");
        (void)newXSproto_portable("Sys::Virt::Event::add_timeout", XS_Sys__Virt__Event_add_timeout, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Event::update_timeout", XS_Sys__Virt__Event_update_timeout, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Event::remove_timeout", XS_Sys__Virt__Event_remove_timeout, file, "$");
        (void)newXSproto_portable("Sys::Virt::Event::_run_handle_callback_helper", XS_Sys__Virt__Event__run_handle_callback_helper, file, "$$$$$");
        (void)newXSproto_portable("Sys::Virt::Event::_run_timeout_callback_helper", XS_Sys__Virt__Event__run_timeout_callback_helper, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Event::_free_callback_opaque_helper", XS_Sys__Virt__Event__free_callback_opaque_helper, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Stream::_new_obj", XS_Sys__Virt__Stream__new_obj, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Stream::send", XS_Sys__Virt__Stream_send, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Stream::recv", XS_Sys__Virt__Stream_recv, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Stream::send_all", XS_Sys__Virt__Stream_send_all, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Stream::recv_all", XS_Sys__Virt__Stream_recv_all, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Stream::add_callback", XS_Sys__Virt__Stream_add_callback, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Stream::update_callback", XS_Sys__Virt__Stream_update_callback, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Stream::remove_callback", XS_Sys__Virt__Stream_remove_callback, file, "$");
        (void)newXSproto_portable("Sys::Virt::Stream::finish", XS_Sys__Virt__Stream_finish, file, "$");
        (void)newXSproto_portable("Sys::Virt::Stream::abort", XS_Sys__Virt__Stream_abort, file, "$");
        (void)newXSproto_portable("Sys::Virt::Stream::DESTROY", XS_Sys__Virt__Stream_DESTROY, file, "$");

    /* Initialisation Section */

#line 5594 "Virt.xs"
    {
      HV *stash;

      virSetErrorFunc(NULL, ignoreVirErrorFunc);
      virInitialize();

      stash = gv_stashpv( "Sys::Virt", TRUE );

      REGISTER_CONSTANT(VIR_CONNECT_RO, CONNECT_RO);
      REGISTER_CONSTANT(VIR_CONNECT_NO_ALIASES, CONNECT_NO_ALIASES);

      REGISTER_CONSTANT(VIR_CRED_USERNAME, CRED_USERNAME);
      REGISTER_CONSTANT(VIR_CRED_AUTHNAME, CRED_AUTHNAME);
      REGISTER_CONSTANT(VIR_CRED_LANGUAGE, CRED_LANGUAGE);
      REGISTER_CONSTANT(VIR_CRED_CNONCE, CRED_CNONCE);
      REGISTER_CONSTANT(VIR_CRED_PASSPHRASE, CRED_PASSPHRASE);
      REGISTER_CONSTANT(VIR_CRED_ECHOPROMPT, CRED_ECHOPROMPT);
      REGISTER_CONSTANT(VIR_CRED_NOECHOPROMPT, CRED_NOECHOPROMPT);
      REGISTER_CONSTANT(VIR_CRED_REALM, CRED_REALM);
      REGISTER_CONSTANT(VIR_CRED_EXTERNAL, CRED_EXTERNAL);


      /* Don't bother with VIR_CPU_COMPARE_ERROR since we die in that case */
      REGISTER_CONSTANT(VIR_CPU_COMPARE_INCOMPATIBLE, CPU_COMPARE_INCOMPATIBLE);
      REGISTER_CONSTANT(VIR_CPU_COMPARE_IDENTICAL, CPU_COMPARE_IDENTICAL);
      REGISTER_CONSTANT(VIR_CPU_COMPARE_SUPERSET, CPU_COMPARE_SUPERSET);


      REGISTER_CONSTANT(VIR_NODE_SUSPEND_TARGET_MEM, NODE_SUSPEND_TARGET_MEM);
      REGISTER_CONSTANT(VIR_NODE_SUSPEND_TARGET_DISK, NODE_SUSPEND_TARGET_DISK);
      REGISTER_CONSTANT(VIR_NODE_SUSPEND_TARGET_HYBRID, NODE_SUSPEND_TARGET_HYBRID);


      REGISTER_CONSTANT(VIR_NODE_CPU_STATS_ALL_CPUS, NODE_CPU_STATS_ALL_CPUS);
      REGISTER_CONSTANT(VIR_NODE_MEMORY_STATS_ALL_CELLS, NODE_MEMORY_STATS_ALL_CELLS);


      stash = gv_stashpv( "Sys::Virt::Event", TRUE );

      REGISTER_CONSTANT(VIR_EVENT_HANDLE_READABLE, HANDLE_READABLE);
      REGISTER_CONSTANT(VIR_EVENT_HANDLE_WRITABLE, HANDLE_WRITABLE);
      REGISTER_CONSTANT(VIR_EVENT_HANDLE_ERROR, HANDLE_ERROR);
      REGISTER_CONSTANT(VIR_EVENT_HANDLE_HANGUP, HANDLE_HANGUP);


      stash = gv_stashpv( "Sys::Virt::Domain", TRUE );
      REGISTER_CONSTANT(VIR_DOMAIN_NOSTATE, STATE_NOSTATE);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING, STATE_RUNNING);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCKED, STATE_BLOCKED);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED, STATE_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN, STATE_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF, STATE_SHUTOFF);
      REGISTER_CONSTANT(VIR_DOMAIN_CRASHED, STATE_CRASHED);
      REGISTER_CONSTANT(VIR_DOMAIN_PMSUSPENDED, STATE_PMSUSPENDED);

      REGISTER_CONSTANT(VIR_DUMP_CRASH, DUMP_CRASH);
      REGISTER_CONSTANT(VIR_DUMP_LIVE, DUMP_LIVE);
      REGISTER_CONSTANT(VIR_DUMP_BYPASS_CACHE, DUMP_BYPASS_CACHE);
      REGISTER_CONSTANT(VIR_DUMP_RESET, DUMP_RESET);

      REGISTER_CONSTANT(VIR_DOMAIN_SAVE_BYPASS_CACHE, SAVE_BYPASS_CACHE);
      REGISTER_CONSTANT(VIR_DOMAIN_SAVE_RUNNING, SAVE_RUNNING);
      REGISTER_CONSTANT(VIR_DOMAIN_SAVE_PAUSED, SAVE_PAUSED);

      REGISTER_CONSTANT(VIR_DOMAIN_UNDEFINE_MANAGED_SAVE, UNDEFINE_MANAGED_SAVE);
      REGISTER_CONSTANT(VIR_DOMAIN_UNDEFINE_SNAPSHOTS_METADATA, UNDEFINE_SNAPSHOTS_METADATA);

      REGISTER_CONSTANT(VIR_DOMAIN_START_PAUSED, START_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_START_AUTODESTROY, START_AUTODESTROY);
      REGISTER_CONSTANT(VIR_DOMAIN_START_BYPASS_CACHE, START_BYPASS_CACHE);
      REGISTER_CONSTANT(VIR_DOMAIN_START_FORCE_BOOT, START_FORCE_BOOT);

      REGISTER_CONSTANT(VIR_DOMAIN_NOSTATE_UNKNOWN, STATE_NOSTATE_UNKNOWN);

      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_UNKNOWN, STATE_RUNNING_UNKNOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_BOOTED, STATE_RUNNING_BOOTED);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_MIGRATED, STATE_RUNNING_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_RESTORED, STATE_RUNNING_RESTORED);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_FROM_SNAPSHOT, STATE_RUNNING_FROM_SNAPSHOT);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_UNPAUSED, STATE_RUNNING_UNPAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_MIGRATION_CANCELED, STATE_RUNNING_MIGRATION_CANCELED);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_SAVE_CANCELED, STATE_RUNNING_SAVE_CANCELED);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_WAKEUP, STATE_RUNNING_WAKEUP);

      REGISTER_CONSTANT(VIR_DOMAIN_BLOCKED_UNKNOWN, STATE_RUNNING_UNKNOWN);

      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_UNKNOWN, STATE_PAUSED_UNKNOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_USER, STATE_PAUSED_USER);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_MIGRATION, STATE_PAUSED_MIGRATION);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_SAVE, STATE_PAUSED_SAVE);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_DUMP, STATE_PAUSED_DUMP);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_IOERROR, STATE_PAUSED_IOERROR);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_WATCHDOG, STATE_PAUSED_WATCHDOG);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_FROM_SNAPSHOT, STATE_PAUSED_FROM_SNAPSHOT);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_SHUTTING_DOWN, STATE_PAUSED_SHUTTING_DOWN);

      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_UNKNOWN, STATE_SHUTDOWN_UNKNOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_USER, STATE_SHUTDOWN_USER);

      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_UNKNOWN, STATE_SHUTOFF_UNKNOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_SHUTDOWN, STATE_SHUTOFF_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_DESTROYED, STATE_SHUTOFF_DESTROYED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_CRASHED, STATE_SHUTOFF_CRASHED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_MIGRATED, STATE_SHUTOFF_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_SAVED, STATE_SHUTOFF_SAVED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_FAILED, STATE_SHUTOFF_FAILED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_FROM_SNAPSHOT, STATE_SHUTOFF_FROM_SNAPSHOT);

      REGISTER_CONSTANT(VIR_DOMAIN_CRASHED_UNKNOWN, STATE_CRASHED_UNKNOWN);

      REGISTER_CONSTANT(VIR_DOMAIN_PMSUSPENDED_UNKNOWN, STATE_PMSUSPENDED_UNKNOWN);

      REGISTER_CONSTANT(VIR_DOMAIN_OPEN_GRAPHICS_SKIPAUTH, OPEN_GRAPHICS_SKIPAUTH);

      REGISTER_CONSTANT(VIR_DOMAIN_CONSOLE_FORCE, OPEN_CONSOLE_FORCE);
      REGISTER_CONSTANT(VIR_DOMAIN_CONSOLE_SAFE, OPEN_CONSOLE_SAFE);

      /* NB: skip VIR_DOMAIN_SCHED_FIELD_* constants, because
         those are not used from Perl code - handled internally
         in the XS layer */

      REGISTER_CONSTANT(VIR_MIGRATE_LIVE, MIGRATE_LIVE);
      REGISTER_CONSTANT(VIR_MIGRATE_PEER2PEER, MIGRATE_PEER2PEER);
      REGISTER_CONSTANT(VIR_MIGRATE_TUNNELLED, MIGRATE_TUNNELLED);
      REGISTER_CONSTANT(VIR_MIGRATE_PERSIST_DEST, MIGRATE_PERSIST_DEST);
      REGISTER_CONSTANT(VIR_MIGRATE_UNDEFINE_SOURCE, MIGRATE_UNDEFINE_SOURCE);
      REGISTER_CONSTANT(VIR_MIGRATE_PAUSED, MIGRATE_PAUSED);
      REGISTER_CONSTANT(VIR_MIGRATE_NON_SHARED_DISK, MIGRATE_NON_SHARED_DISK);
      REGISTER_CONSTANT(VIR_MIGRATE_NON_SHARED_INC, MIGRATE_NON_SHARED_INC);
      REGISTER_CONSTANT(VIR_MIGRATE_CHANGE_PROTECTION, MIGRATE_CHANGE_PROTECTION);
      REGISTER_CONSTANT(VIR_MIGRATE_UNSAFE, MIGRATE_UNSAFE);


      REGISTER_CONSTANT(VIR_DOMAIN_XML_SECURE, XML_SECURE);
      REGISTER_CONSTANT(VIR_DOMAIN_XML_INACTIVE, XML_INACTIVE);
      REGISTER_CONSTANT(VIR_DOMAIN_XML_UPDATE_CPU, XML_UPDATE_CPU);


      REGISTER_CONSTANT(VIR_MEMORY_VIRTUAL, MEMORY_VIRTUAL);
      REGISTER_CONSTANT(VIR_MEMORY_PHYSICAL, MEMORY_PHYSICAL);


      REGISTER_CONSTANT(VIR_VCPU_OFFLINE, VCPU_OFFLINE);
      REGISTER_CONSTANT(VIR_VCPU_RUNNING, VCPU_RUNNING);
      REGISTER_CONSTANT(VIR_VCPU_BLOCKED, VCPU_BLOCKED);


      REGISTER_CONSTANT(VIR_KEYCODE_SET_LINUX, KEYCODE_SET_LINUX);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_XT, KEYCODE_SET_XT);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_ATSET1, KEYCODE_SET_ATSET1);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_ATSET2, KEYCODE_SET_ATSET2);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_ATSET3, KEYCODE_SET_ATSET3);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_OSX, KEYCODE_SET_OSX);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_XT_KBD, KEYCODE_SET_XT_KBD);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_USB, KEYCODE_SET_USB);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_WIN32, KEYCODE_SET_WIN32);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_RFB, KEYCODE_SET_RFB);


      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED, EVENT_DEFINED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_UNDEFINED, EVENT_UNDEFINED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED, EVENT_STARTED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED, EVENT_SUSPENDED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED, EVENT_RESUMED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED, EVENT_STOPPED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SHUTDOWN, EVENT_SHUTDOWN);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED_ADDED, EVENT_DEFINED_ADDED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED_UPDATED, EVENT_DEFINED_UPDATED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_UNDEFINED_REMOVED, EVENT_UNDEFINED_REMOVED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_BOOTED, EVENT_STARTED_BOOTED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_MIGRATED, EVENT_STARTED_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_RESTORED, EVENT_STARTED_RESTORED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_FROM_SNAPSHOT, EVENT_STARTED_FROM_SNAPSHOT);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_WAKEUP, EVENT_STARTED_WAKEUP);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_PAUSED, EVENT_SUSPENDED_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_MIGRATED, EVENT_SUSPENDED_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_IOERROR, EVENT_SUSPENDED_IOERROR);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_WATCHDOG, EVENT_SUSPENDED_WATCHDOG);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_RESTORED, EVENT_SUSPENDED_RESTORED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_FROM_SNAPSHOT, EVENT_SUSPENDED_FROM_SNAPSHOT);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_UNPAUSED, EVENT_RESUMED_UNPAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_MIGRATED, EVENT_RESUMED_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_FROM_SNAPSHOT, EVENT_RESUMED_FROM_SNAPSHOT);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_SHUTDOWN, EVENT_STOPPED_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_DESTROYED, EVENT_STOPPED_DESTROYED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_CRASHED, EVENT_STOPPED_CRASHED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_MIGRATED, EVENT_STOPPED_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_SAVED, EVENT_STOPPED_SAVED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_FAILED, EVENT_STOPPED_FAILED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_FROM_SNAPSHOT, EVENT_STOPPED_FROM_SNAPSHOT);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SHUTDOWN_FINISHED, EVENT_SHUTDOWN_FINISHED);


      REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_OK, CONTROL_OK);
      REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_JOB, CONTROL_JOB);
      REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_OCCUPIED, CONTROL_OCCUPIED);
      REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_ERROR, CONTROL_ERROR);


      REGISTER_CONSTANT(VIR_DOMAIN_DEVICE_MODIFY_CURRENT, DEVICE_MODIFY_CURRENT);
      REGISTER_CONSTANT(VIR_DOMAIN_DEVICE_MODIFY_LIVE, DEVICE_MODIFY_LIVE);
      REGISTER_CONSTANT(VIR_DOMAIN_DEVICE_MODIFY_CONFIG, DEVICE_MODIFY_CONFIG);
      REGISTER_CONSTANT(VIR_DOMAIN_DEVICE_MODIFY_FORCE, DEVICE_MODIFY_FORCE);


      REGISTER_CONSTANT(VIR_DOMAIN_MEM_CURRENT, MEM_CURRENT);
      REGISTER_CONSTANT(VIR_DOMAIN_MEM_LIVE, MEM_LIVE);
      REGISTER_CONSTANT(VIR_DOMAIN_MEM_CONFIG, MEM_CONFIG);
      REGISTER_CONSTANT(VIR_DOMAIN_MEM_MAXIMUM, MEM_MAXIMUM);


      REGISTER_CONSTANT(VIR_DOMAIN_AFFECT_CURRENT, AFFECT_CURRENT);
      REGISTER_CONSTANT(VIR_DOMAIN_AFFECT_LIVE, AFFECT_LIVE);
      REGISTER_CONSTANT(VIR_DOMAIN_AFFECT_CONFIG, AFFECT_CONFIG);


      REGISTER_CONSTANT(VIR_DOMAIN_JOB_NONE, JOB_NONE);
      REGISTER_CONSTANT(VIR_DOMAIN_JOB_BOUNDED, JOB_BOUNDED);
      REGISTER_CONSTANT(VIR_DOMAIN_JOB_UNBOUNDED, JOB_UNBOUNDED);
      REGISTER_CONSTANT(VIR_DOMAIN_JOB_COMPLETED, JOB_COMPLETED);
      REGISTER_CONSTANT(VIR_DOMAIN_JOB_FAILED, JOB_FAILED);
      REGISTER_CONSTANT(VIR_DOMAIN_JOB_CANCELLED, JOB_CANCELLED);

      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_UNKNOWN, BLOCK_JOB_TYPE_UNKNOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_PULL, BLOCK_JOB_TYPE_PULL);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_COPY, BLOCK_JOB_TYPE_COPY);

      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_COMPLETED, BLOCK_JOB_COMPLETED);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_FAILED, BLOCK_JOB_FAILED);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_CANCELED, BLOCK_JOB_CANCELED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_LIFECYCLE, EVENT_ID_LIFECYCLE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_REBOOT, EVENT_ID_REBOOT);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_RTC_CHANGE, EVENT_ID_RTC_CHANGE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_WATCHDOG, EVENT_ID_WATCHDOG);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_IO_ERROR, EVENT_ID_IO_ERROR);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_GRAPHICS, EVENT_ID_GRAPHICS);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_IO_ERROR_REASON, EVENT_ID_IO_ERROR_REASON);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_CONTROL_ERROR, EVENT_ID_CONTROL_ERROR);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_BLOCK_JOB, EVENT_ID_BLOCK_JOB);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_DISK_CHANGE, EVENT_ID_DISK_CHANGE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_PMSUSPEND, EVENT_ID_PMSUSPEND);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_PMWAKEUP, EVENT_ID_PMWAKEUP);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_TRAY_CHANGE, EVENT_ID_TRAY_CHANGE);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_NONE, EVENT_WATCHDOG_NONE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_PAUSE, EVENT_WATCHDOG_PAUSE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_RESET, EVENT_WATCHDOG_RESET);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_POWEROFF, EVENT_WATCHDOG_POWEROFF);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_SHUTDOWN, EVENT_WATCHDOG_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_DEBUG, EVENT_WATCHDOG_DEBUG);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_IO_ERROR_NONE, EVENT_IO_ERROR_NONE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_IO_ERROR_PAUSE, EVENT_IO_ERROR_PAUSE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_IO_ERROR_REPORT, EVENT_IO_ERROR_REPORT);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_CONNECT, EVENT_GRAPHICS_CONNECT);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_INITIALIZE, EVENT_GRAPHICS_INITIALIZE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_DISCONNECT, EVENT_GRAPHICS_DISCONNECT);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_ADDRESS_IPV4, EVENT_GRAPHICS_ADDRESS_IPV4);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_ADDRESS_IPV6, EVENT_GRAPHICS_ADDRESS_IPV6);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_ADDRESS_UNIX, EVENT_GRAPHICS_ADDRESS_UNIX);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DISK_CHANGE_MISSING_ON_START, EVENT_DISK_CHANGE_MISSING_ON_START);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_TRAY_CHANGE_OPEN, EVENT_TRAY_CHANGE_OPEN);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_TRAY_CHANGE_CLOSE, EVENT_TRAY_CHANGE_CLOSE);

      REGISTER_CONSTANT_STR(VIR_DOMAIN_MEMORY_HARD_LIMIT, MEMORY_HARD_LIMIT);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_MEMORY_SOFT_LIMIT, MEMORY_SOFT_LIMIT);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_MEMORY_MIN_GUARANTEE, MEMORY_MIN_GUARANTEE);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_MEMORY_SWAP_HARD_LIMIT, MEMORY_SWAP_HARD_LIMIT);
      REGISTER_CONSTANT_ULL(VIR_DOMAIN_MEMORY_PARAM_UNLIMITED, MEMORY_PARAM_UNLIMITED);

      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLKIO_WEIGHT, BLKIO_WEIGHT);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLKIO_DEVICE_WEIGHT, BLKIO_DEVICE_WEIGHT);

      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_CPU_SHARES, SCHEDULER_CPU_SHARES);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_VCPU_PERIOD, SCHEDULER_VCPU_PERIOD);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_VCPU_QUOTA, SCHEDULER_VCPU_QUOTA);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_WEIGHT, SCHEDULER_WEIGHT);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_CAP, SCHEDULER_CAP);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_LIMIT, SCHEDULER_LIMIT);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_RESERVATION, SCHEDULER_RESERVATION);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_SHARES, SCHEDULER_SHARES);


      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_SWAP_IN, MEMORY_STAT_SWAP_IN);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_SWAP_OUT, MEMORY_STAT_SWAP_OUT);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_MAJOR_FAULT, MEMORY_STAT_MAJOR_FAULT);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_MINOR_FAULT, MEMORY_STAT_MINOR_FAULT);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_UNUSED, MEMORY_STAT_UNUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_AVAILABLE, MEMORY_STAT_AVAILABLE);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_ACTUAL_BALLOON, MEMORY_STAT_ACTUAL_BALLOON);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_RSS, MEMORY_STAT_RSS);


      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_TOTAL_BYTES_SEC, BLOCK_IOTUNE_TOTAL_BYTES_SEC);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_READ_BYTES_SEC, BLOCK_IOTUNE_READ_BYTES_SEC);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_WRITE_BYTES_SEC, BLOCK_IOTUNE_WRITE_BYTES_SEC);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_TOTAL_IOPS_SEC, BLOCK_IOTUNE_TOTAL_BYTES_SEC);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_READ_IOPS_SEC, BLOCK_IOTUNE_READ_BYTES_SEC);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_WRITE_IOPS_SEC, BLOCK_IOTUNE_WRITE_BYTES_SEC);


      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_RESIZE_BYTES, BLOCK_RESIZE_BYTES);


      REGISTER_CONSTANT_STR(VIR_DOMAIN_NUMA_NODESET, NUMA_NODESET);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_NUMA_MODE, NUMA_MODE);

      REGISTER_CONSTANT(VIR_DOMAIN_NUMATUNE_MEM_STRICT, NUMATUNE_MEM_STRICT);
      REGISTER_CONSTANT(VIR_DOMAIN_NUMATUNE_MEM_PREFERRED, NUMATUNE_MEM_PREFERRED);
      REGISTER_CONSTANT(VIR_DOMAIN_NUMATUNE_MEM_INTERLEAVE, NUMATUNE_MEM_INTERLEAVE);


      REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_IN_AVERAGE, BANDWIDTH_IN_AVERAGE);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_IN_PEAK, BANDWIDTH_IN_PEAK);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_IN_BURST, BANDWIDTH_IN_BURST);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_OUT_AVERAGE, BANDWIDTH_OUT_AVERAGE);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_OUT_PEAK, BANDWIDTH_OUT_PEAK);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_OUT_BURST, BANDWIDTH_OUT_BURST);


      REGISTER_CONSTANT(VIR_DOMAIN_VCPU_CURRENT, VCPU_CURRENT);
      REGISTER_CONSTANT(VIR_DOMAIN_VCPU_LIVE, VCPU_LIVE);
      REGISTER_CONSTANT(VIR_DOMAIN_VCPU_CONFIG, VCPU_CONFIG);
      REGISTER_CONSTANT(VIR_DOMAIN_VCPU_MAXIMUM, VCPU_MAXIMUM);


      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_DEFAULT, SHUTDOWN_DEFAULT);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_ACPI_POWER_BTN, SHUTDOWN_ACPI_POWER_BTN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_GUEST_AGENT, SHUTDOWN_GUEST_AGENT);


      REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_DEFAULT, REBOOT_DEFAULT);
      REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_ACPI_POWER_BTN, REBOOT_ACPI_POWER_BTN);
      REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_GUEST_AGENT, REBOOT_GUEST_AGENT);


      REGISTER_CONSTANT(VIR_DOMAIN_DESTROY_DEFAULT, DESTROY_DEFAULT);
      REGISTER_CONSTANT(VIR_DOMAIN_DESTROY_GRACEFUL, DESTROY_GRACEFUL);


      REGISTER_CONSTANT(VIR_DOMAIN_METADATA_DESCRIPTION, METADATA_DESCRIPTION);
      REGISTER_CONSTANT(VIR_DOMAIN_METADATA_TITLE, METADATA_TITLE);
      REGISTER_CONSTANT(VIR_DOMAIN_METADATA_ELEMENT, METADATA_ELEMENT);

      REGISTER_CONSTANT(VIR_DOMAIN_DISK_ERROR_NONE, DISK_ERROR_NONE);
      REGISTER_CONSTANT(VIR_DOMAIN_DISK_ERROR_NO_SPACE, DISK_ERROR_NO_SPACE);
      REGISTER_CONSTANT(VIR_DOMAIN_DISK_ERROR_UNSPEC, DISK_ERROR_UNSPEC);


      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_ABORT_ASYNC, BLOCK_JOB_ABORT_ASYNC);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_ABORT_PIVOT, BLOCK_JOB_ABORT_PIVOT);

      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_SHALLOW, BLOCK_REBASE_SHALLOW);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_REUSE_EXT, BLOCK_REBASE_REUSE_EXT);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_COPY_RAW, BLOCK_REBASE_COPY_RAW);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_COPY, BLOCK_REBASE_COPY);


      stash = gv_stashpv( "Sys::Virt::DomainSnapshot", TRUE );
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_DELETE_CHILDREN, DELETE_CHILDREN);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_DELETE_METADATA_ONLY, DELETE_METADATA_ONLY);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_DELETE_CHILDREN_ONLY, DELETE_CHILDREN_ONLY);

      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_REDEFINE, CREATE_REDEFINE);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_CURRENT, CREATE_CURRENT);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_NO_METADATA, CREATE_NO_METADATA);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_HALT, CREATE_HALT);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_DISK_ONLY, CREATE_DISK_ONLY);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_REUSE_EXT, CREATE_REUSE_EXT);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_QUIESCE, CREATE_QUIESCE);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_ATOMIC, CREATE_ATOMIC);

      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_ROOTS, LIST_ROOTS);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_DESCENDANTS, LIST_DESCENDANTS);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_METADATA, LIST_METADATA);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_LEAVES, LIST_LEAVES);

      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_REVERT_RUNNING, REVERT_RUNNING);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_REVERT_PAUSED, REVERT_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_REVERT_FORCE, REVERT_FORCE);

      stash = gv_stashpv( "Sys::Virt::StoragePool", TRUE );
      REGISTER_CONSTANT(VIR_STORAGE_POOL_INACTIVE, STATE_INACTIVE);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILDING, STATE_BUILDING);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_RUNNING, STATE_RUNNING);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_DEGRADED, STATE_DEGRADED);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_INACCESSIBLE, STATE_INACCESSIBLE);

      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_NEW, BUILD_NEW);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_REPAIR, BUILD_REPAIR);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_RESIZE, BUILD_RESIZE);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_NO_OVERWRITE, BUILD_NO_OVERWRITE);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_OVERWRITE, BUILD_OVERWRITE);

      REGISTER_CONSTANT(VIR_STORAGE_POOL_DELETE_NORMAL, DELETE_NORMAL);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_DELETE_ZEROED, DELETE_ZEROED);


      stash = gv_stashpv( "Sys::Virt::Network", TRUE );
      REGISTER_CONSTANT(VIR_NETWORK_XML_INACTIVE, XML_INACTIVE);


      stash = gv_stashpv( "Sys::Virt::Interface", TRUE );
      REGISTER_CONSTANT(VIR_INTERFACE_XML_INACTIVE, XML_INACTIVE);


      stash = gv_stashpv( "Sys::Virt::StorageVol", TRUE );
      REGISTER_CONSTANT(VIR_STORAGE_VOL_FILE, TYPE_FILE);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_BLOCK, TYPE_BLOCK);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_DIR, TYPE_DIR);

      REGISTER_CONSTANT(VIR_STORAGE_VOL_DELETE_NORMAL, DELETE_NORMAL);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_DELETE_ZEROED, DELETE_ZEROED);


      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_ZERO, WIPE_ALG_ZERO);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_NNSA, WIPE_ALG_NNSA);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_DOD, WIPE_ALG_DOD);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_BSI, WIPE_ALG_BSI);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_GUTMANN, WIPE_ALG_GUTMANN);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_SCHNEIER, WIPE_ALG_SCHNEIER);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_PFITZNER7, WIPE_ALG_PFITZNER7);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_PFITZNER33, WIPE_ALG_PFITZNER33);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_RANDOM, WIPE_ALG_RANDOM);

      REGISTER_CONSTANT(VIR_STORAGE_VOL_RESIZE_ALLOCATE, RESIZE_ALLOCATE);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_RESIZE_DELTA, RESIZE_DELTA);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_RESIZE_SHRINK, RESIZE_SHRINK);


      stash = gv_stashpv( "Sys::Virt::Secret", TRUE );
      REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_NONE, USAGE_TYPE_NONE);
      REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_VOLUME, USAGE_TYPE_VOLUME);
      REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_CEPH, USAGE_TYPE_CEPH);



      stash = gv_stashpv( "Sys::Virt::Stream", TRUE );
      REGISTER_CONSTANT(VIR_STREAM_NONBLOCK, NONBLOCK);

      REGISTER_CONSTANT(VIR_STREAM_EVENT_READABLE, EVENT_READABLE);
      REGISTER_CONSTANT(VIR_STREAM_EVENT_WRITABLE, EVENT_WRITABLE);
      REGISTER_CONSTANT(VIR_STREAM_EVENT_ERROR, EVENT_ERROR);
      REGISTER_CONSTANT(VIR_STREAM_EVENT_HANGUP, EVENT_HANGUP);



      stash = gv_stashpv( "Sys::Virt::Error", TRUE );

      REGISTER_CONSTANT(VIR_ERR_NONE, LEVEL_NONE);
      REGISTER_CONSTANT(VIR_ERR_WARNING, LEVEL_WARNING);
      REGISTER_CONSTANT(VIR_ERR_ERROR, LEVEL_ERROR);

      REGISTER_CONSTANT(VIR_FROM_NONE, FROM_NONE);
      REGISTER_CONSTANT(VIR_FROM_XEN, FROM_XEN);
      REGISTER_CONSTANT(VIR_FROM_XEND, FROM_XEND);
      REGISTER_CONSTANT(VIR_FROM_XENSTORE, FROM_XENSTORE);
      REGISTER_CONSTANT(VIR_FROM_SEXPR, FROM_SEXPR);
      REGISTER_CONSTANT(VIR_FROM_XML, FROM_XML);
      REGISTER_CONSTANT(VIR_FROM_DOM, FROM_DOM);
      REGISTER_CONSTANT(VIR_FROM_RPC, FROM_RPC);
      REGISTER_CONSTANT(VIR_FROM_PROXY, FROM_PROXY);
      REGISTER_CONSTANT(VIR_FROM_CONF, FROM_CONF);
      REGISTER_CONSTANT(VIR_FROM_QEMU, FROM_QEMU);
      REGISTER_CONSTANT(VIR_FROM_NET, FROM_NET);
      REGISTER_CONSTANT(VIR_FROM_TEST, FROM_TEST);
      REGISTER_CONSTANT(VIR_FROM_REMOTE, FROM_REMOTE);
      REGISTER_CONSTANT(VIR_FROM_OPENVZ, FROM_OPENVZ);
      REGISTER_CONSTANT(VIR_FROM_XENXM, FROM_XENXM);
      REGISTER_CONSTANT(VIR_FROM_STATS_LINUX, FROM_STATS_LINUX);
      REGISTER_CONSTANT(VIR_FROM_LXC, FROM_LXC);
      REGISTER_CONSTANT(VIR_FROM_STORAGE, FROM_STORAGE);
      REGISTER_CONSTANT(VIR_FROM_NETWORK, FROM_NETWORK);
      REGISTER_CONSTANT(VIR_FROM_DOMAIN, FROM_DOMAIN);
      REGISTER_CONSTANT(VIR_FROM_UML, FROM_UML);
      REGISTER_CONSTANT(VIR_FROM_NODEDEV, FROM_NODEDEV);
      REGISTER_CONSTANT(VIR_FROM_XEN_INOTIFY, FROM_XEN_INOTIFY);
      REGISTER_CONSTANT(VIR_FROM_SECURITY, FROM_SECURITY);
      REGISTER_CONSTANT(VIR_FROM_VBOX, FROM_VBOX);
      REGISTER_CONSTANT(VIR_FROM_INTERFACE, FROM_INTERFACE);
      REGISTER_CONSTANT(VIR_FROM_ONE, FROM_ONE);
      REGISTER_CONSTANT(VIR_FROM_ESX, FROM_ESX);
      REGISTER_CONSTANT(VIR_FROM_PHYP, FROM_PHYP);
      REGISTER_CONSTANT(VIR_FROM_SECRET, FROM_SECRET);
      REGISTER_CONSTANT(VIR_FROM_CPU, FROM_CPU);
      REGISTER_CONSTANT(VIR_FROM_XENAPI, FROM_XENAPI);
      REGISTER_CONSTANT(VIR_FROM_NWFILTER, FROM_NWFILTER);
      REGISTER_CONSTANT(VIR_FROM_HOOK, FROM_HOOK);
      REGISTER_CONSTANT(VIR_FROM_DOMAIN_SNAPSHOT, FROM_DOMAIN_SNAPSHOT);
      REGISTER_CONSTANT(VIR_FROM_AUDIT, FROM_AUDIT);
      REGISTER_CONSTANT(VIR_FROM_SYSINFO, FROM_SYSINFO);
      REGISTER_CONSTANT(VIR_FROM_STREAMS, FROM_STREAMS);
      REGISTER_CONSTANT(VIR_FROM_VMWARE, FROM_VMWARE);
      REGISTER_CONSTANT(VIR_FROM_EVENT, FROM_EVENT);
      REGISTER_CONSTANT(VIR_FROM_LIBXL, FROM_LIBXL);
      REGISTER_CONSTANT(VIR_FROM_LOCKING, FROM_LOCKING);
      REGISTER_CONSTANT(VIR_FROM_HYPERV, FROM_HYPERV);
      REGISTER_CONSTANT(VIR_FROM_CAPABILITIES, FROM_CAPABILITIES);
      REGISTER_CONSTANT(VIR_FROM_AUTH, FROM_AUTH);
      REGISTER_CONSTANT(VIR_FROM_URI, FROM_URI);
      REGISTER_CONSTANT(VIR_FROM_DBUS, FROM_DBUS);


      REGISTER_CONSTANT(VIR_ERR_OK, ERR_OK);
      REGISTER_CONSTANT(VIR_ERR_INTERNAL_ERROR, ERR_INTERNAL_ERROR);
      REGISTER_CONSTANT(VIR_ERR_NO_MEMORY, ERR_NO_MEMORY);
      REGISTER_CONSTANT(VIR_ERR_NO_SUPPORT, ERR_NO_SUPPORT);
      REGISTER_CONSTANT(VIR_ERR_UNKNOWN_HOST, ERR_UNKNOWN_HOST);
      REGISTER_CONSTANT(VIR_ERR_NO_CONNECT, ERR_NO_CONNECT);
      REGISTER_CONSTANT(VIR_ERR_INVALID_CONN, ERR_INVALID_CONN);
      REGISTER_CONSTANT(VIR_ERR_INVALID_DOMAIN, ERR_INVALID_DOMAIN);
      REGISTER_CONSTANT(VIR_ERR_INVALID_ARG, ERR_INVALID_ARG);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_FAILED, ERR_OPERATION_FAILED);
      REGISTER_CONSTANT(VIR_ERR_GET_FAILED, ERR_GET_FAILED);
      REGISTER_CONSTANT(VIR_ERR_POST_FAILED, ERR_POST_FAILED);
      REGISTER_CONSTANT(VIR_ERR_HTTP_ERROR, ERR_HTTP_ERROR);
      REGISTER_CONSTANT(VIR_ERR_SEXPR_SERIAL, ERR_SEXPR_SERIAL);
      REGISTER_CONSTANT(VIR_ERR_NO_XEN, ERR_NO_XEN);
      REGISTER_CONSTANT(VIR_ERR_XEN_CALL, ERR_XEN_CALL);
      REGISTER_CONSTANT(VIR_ERR_OS_TYPE, ERR_OS_TYPE);
      REGISTER_CONSTANT(VIR_ERR_NO_KERNEL, ERR_NO_KERNEL);
      REGISTER_CONSTANT(VIR_ERR_NO_ROOT, ERR_NO_ROOT);
      REGISTER_CONSTANT(VIR_ERR_NO_SOURCE, ERR_NO_SOURCE);
      REGISTER_CONSTANT(VIR_ERR_NO_TARGET, ERR_NO_TARGET);
      REGISTER_CONSTANT(VIR_ERR_NO_NAME, ERR_NO_NAME);
      REGISTER_CONSTANT(VIR_ERR_NO_OS, ERR_NO_OS);
      REGISTER_CONSTANT(VIR_ERR_NO_DEVICE, ERR_NO_DEVICE);
      REGISTER_CONSTANT(VIR_ERR_NO_XENSTORE, ERR_NO_XENSTORE);
      REGISTER_CONSTANT(VIR_ERR_DRIVER_FULL, ERR_DRIVER_FULL);
      REGISTER_CONSTANT(VIR_ERR_CALL_FAILED, ERR_CALL_FAILED);
      REGISTER_CONSTANT(VIR_ERR_XML_ERROR, ERR_XML_ERROR);
      REGISTER_CONSTANT(VIR_ERR_DOM_EXIST, ERR_DOM_EXIST);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_DENIED, ERR_OPERATIONED_DENIED);
      REGISTER_CONSTANT(VIR_ERR_OPEN_FAILED, ERR_OPEN_FAILED);
      REGISTER_CONSTANT(VIR_ERR_READ_FAILED, ERR_READ_FAILED);
      REGISTER_CONSTANT(VIR_ERR_PARSE_FAILED, ERR_PARSE_FAILED);
      REGISTER_CONSTANT(VIR_ERR_CONF_SYNTAX, ERR_CONF_SYNTAX);
      REGISTER_CONSTANT(VIR_ERR_WRITE_FAILED, ERR_WRITE_FAILED);
      REGISTER_CONSTANT(VIR_ERR_XML_DETAIL, ERR_XML_DETAIL);
      REGISTER_CONSTANT(VIR_ERR_INVALID_NETWORK, ERR_INVALID_NETWORK);
      REGISTER_CONSTANT(VIR_ERR_NETWORK_EXIST, ERR_NETWORK_EXIST);
      REGISTER_CONSTANT(VIR_ERR_SYSTEM_ERROR, ERR_SYSTEM_ERROR);
      REGISTER_CONSTANT(VIR_ERR_RPC, ERR_RPC);
      REGISTER_CONSTANT(VIR_ERR_GNUTLS_ERROR, ERR_GNUTLS_ERROR);
      REGISTER_CONSTANT(VIR_WAR_NO_NETWORK, WAR_NO_NETWORK);
      REGISTER_CONSTANT(VIR_ERR_NO_DOMAIN, ERR_NO_DOMAIN);
      REGISTER_CONSTANT(VIR_ERR_NO_NETWORK, ERR_NO_NETWORK);
      REGISTER_CONSTANT(VIR_ERR_INVALID_MAC, ERR_INVALID_MAC);
      REGISTER_CONSTANT(VIR_ERR_AUTH_FAILED, ERR_AUTH_FAILED);
      REGISTER_CONSTANT(VIR_ERR_INVALID_STORAGE_POOL, ERR_INVALID_STORAGE_POOL);
      REGISTER_CONSTANT(VIR_ERR_INVALID_STORAGE_VOL, ERR_INVALID_STORAGE_VOL);
      REGISTER_CONSTANT(VIR_WAR_NO_STORAGE, WAR_NO_STORAGE);
      REGISTER_CONSTANT(VIR_ERR_NO_STORAGE_POOL, ERR_NO_STORAGE_POOL);
      REGISTER_CONSTANT(VIR_ERR_NO_STORAGE_VOL, ERR_NO_STORAGE_VOL);
      REGISTER_CONSTANT(VIR_WAR_NO_NODE, WAR_NO_NODE);
      REGISTER_CONSTANT(VIR_ERR_INVALID_NODE_DEVICE, ERR_INVALID_NODE_DEVICE);
      REGISTER_CONSTANT(VIR_ERR_NO_NODE_DEVICE, ERR_NO_NODE_DEVICE);
      REGISTER_CONSTANT(VIR_ERR_NO_SECURITY_MODEL, ERR_NO_SECURITY_MODEL);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_INVALID, ERR_OPERATION_INVALID);
      REGISTER_CONSTANT(VIR_WAR_NO_INTERFACE, WAR_NO_INTERFACE);
      REGISTER_CONSTANT(VIR_ERR_NO_INTERFACE, ERR_NO_INTERFACE);
      REGISTER_CONSTANT(VIR_ERR_INVALID_INTERFACE, ERR_INVALID_INTERFACE);
      REGISTER_CONSTANT(VIR_ERR_MULTIPLE_INTERFACES, ERR_MULTIPLE_INTERFACES);
      REGISTER_CONSTANT(VIR_WAR_NO_NWFILTER, WAR_NO_NWFILTER);
      REGISTER_CONSTANT(VIR_ERR_INVALID_NWFILTER, ERR_INVALID_NWFILTER);
      REGISTER_CONSTANT(VIR_ERR_NO_NWFILTER, ERR_NO_NWFILTER);
      REGISTER_CONSTANT(VIR_ERR_BUILD_FIREWALL, ERR_BUILD_FIREWALL);
      REGISTER_CONSTANT(VIR_WAR_NO_SECRET, WAR_NO_SECRET);
      REGISTER_CONSTANT(VIR_ERR_INVALID_SECRET, ERR_INVALID_SECRET);
      REGISTER_CONSTANT(VIR_ERR_NO_SECRET, ERR_NO_SECRET);
      REGISTER_CONSTANT(VIR_ERR_CONFIG_UNSUPPORTED, ERR_CONFIG_UNSUPPORTED);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_TIMEOUT, ERR_OPERATION_TIMEOUT);
      REGISTER_CONSTANT(VIR_ERR_MIGRATE_PERSIST_FAILED, ERR_MIGRATE_PERSIST_FAILED);
      REGISTER_CONSTANT(VIR_ERR_HOOK_SCRIPT_FAILED, ERR_HOOK_SCRIPT_FAILED);
      REGISTER_CONSTANT(VIR_ERR_INVALID_DOMAIN_SNAPSHOT, ERR_INVALID_DOMAIN_SNAPSHOT);
      REGISTER_CONSTANT(VIR_ERR_NO_DOMAIN_SNAPSHOT, ERR_NO_DOMAIN_SNAPSHOT);
      REGISTER_CONSTANT(VIR_ERR_INVALID_STREAM, ERR_INVALID_STREAM);
      REGISTER_CONSTANT(VIR_ERR_ARGUMENT_UNSUPPORTED, ERR_ARGUMENT_UNSUPPORTED);
      REGISTER_CONSTANT(VIR_ERR_STORAGE_PROBE_FAILED, ERR_STORAGE_PROBE_FAILED);
      REGISTER_CONSTANT(VIR_ERR_STORAGE_POOL_BUILT, ERR_STORAGE_POOL_BUILT);
      REGISTER_CONSTANT(VIR_ERR_SNAPSHOT_REVERT_RISKY, ERR_SNAPSHOT_REVERT_RISKY);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_ABORTED, ERR_OPERATION_ABORTED);
      REGISTER_CONSTANT(VIR_ERR_AUTH_CANCELLED, ERR_AUTH_CANCELLED);
      REGISTER_CONSTANT(VIR_ERR_NO_DOMAIN_METADATA, ERR_NO_DOMAIN_METADATA);
      REGISTER_CONSTANT(VIR_ERR_MIGRATE_UNSAFE, ERR_MIGRATE_UNSAFE);
      REGISTER_CONSTANT(VIR_ERR_OVERFLOW, ERR_OVERFLOW);
      REGISTER_CONSTANT(VIR_ERR_BLOCK_COPY_ACTIVE, ERR_BLOCK_COPY_ACTIVE);
    }

#line 13749 "Virt.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

